#!/usr/bin/perl --

use strict;

# ŒtH[}bg
my $file_head_format =<<'EOF';
/*---------------------------------------------------------------------------*
  Project:  TwlSDK - libralies - camera
  File:     %1$s

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: $
  $NoKeywords: $
 *---------------------------------------------------------------------------*/

//#define PRINT_DEBUG

#ifdef PRINT_DEBUG
#include <nitro/os/common/printf.h>
#define DBG_PRINTF OS_TPrintf
#else
#define DBG_PRINTF( ... )  ((void)0)
#endif

static BOOL CAMERAi_S_Initialize( CameraSelect camera )
{
EOF

my $file_foot_format =<<'EOF';
    return TRUE;
}
EOF

my $single_format =<<'EOF';
    if (CAMERAi_S_WriteRegister(camera, 0x%02X, 0x%02X) == FALSE)
    {
        DBG_PRINTF("Failed to write a register! (%%d)\n", __LINE__);
        return FALSE;
    }
EOF

my $multi_head_format =<<'EOF';
    {
        const u8 data[] =
        {
EOF

my $multi_foot_format =<<'EOF';
        };
        if (CAMERAi_S_WriteRegisters(camera, 0x%02X, data, %d) == FALSE)
        {
            DBG_PRINTF("Failed to write registers! (%%d)\n", __LINE__);
            return FALSE;
        }
    }
EOF

# s
$file_head_format =~ s/\r?\n/\r\n/g;
$file_foot_format =~ s/\r?\n/\r\n/g;
$single_format =~ s/\r?\n/\r\n/g;
$multi_head_format =~ s/\r?\n/\r\n/g;
$multi_foot_format =~ s/\r?\n/\r\n/g;

my $row_nums = 8;
sub sprint_command {
    my($addr, @value) = @_;
    return sprintf($single_format, $addr, $value[0]) if @value == 1;    # VOCg͕ʘg
    my $result = $multi_head_format;    # ȍ~̓o[XgCg
    for (my $i = 0; $i < @value; $i++) {
        if ($i % $row_nums == 0) {
            $result .= "            " ;
        } else {
            $result .= " " ;
        }
        $result .= sprintf("0x%02X,", $value[$i]);
        if ($i % $row_nums == $row_nums - 1) {
            $result .= "\r\n";
        }
    }
    if (@value % $row_nums != 0) {
        $result .= "\r\n";
    }
    $result .= sprintf($multi_foot_format, $addr, scalar(@value));
    return $result;
}

#烁C

#
# f[^͂LbVāAAAhXo[XgCgɏ
#
my $comment;                    # RgLbV
my @cache;                      # LbVf[^
my $start = -1;                 # LbV̐擪AhX
my @output;                     # o̓f[^

# `FbN
die "USAGE: $0 INFILE [OUTFILE]\n" if $#ARGV != 1 and $#ARGV != 0;

# e평
my $infile = $ARGV[0];
my $outfile = $ARGV[1];
($outfile = $infile) =~ s/\.dat$/.autogen.c/ unless $outfile;

# o̓t@C̃I[v (I[vĂ)
open IN, $infile or die "Cannot open the input file!\n";
open OUT, ">", $outfile or die "Cannot open the output file!\n";

# ͏
while (<IN>) {
    s/[\r\n]+$//;   # delete \r and/or \n
    s|\#|// |g;     # change comment sign
    $comment .= "    $1\r\n" if s|(//.*)||; # Rgo(ƗsƂďo͗\)

    if (/\s*([\w\d]{2})\s+([\w\d]{2})/) {   # f[^o
        my ($addr, $value) = (hex($1), hex($2));
        if ($addr != $start + @cache) {     # AhXAĂȂȂ
            push @output, sprint_command($start, @cache) if (@cache);   # O܂ło
            @cache = ($value);              # ŐV̒l̃Ggɂ
            $start = $addr;
        } else {                            # AhXAĂȂ
            push @cache, $value;            # lǋL
        }
        push @output, $comment;             # ̃^C~OŃRgo
        $comment = "";
    }
    elsif (/\S/) {                          # m͍so (G[ɂׂ)
        warn "UNKNOWN STATEMENT: <<", $_, ">>\n";
    }
}
# ŏIs
push @output, sprint_command($start, @cache) if @cache;
# ͏I
close IN;

# o͏
$outfile =~ s/^.*[\\\/]//;  # get basename to print
printf OUT $file_head_format, $outfile;     # t@Cwb_o
print OUT @output;
printf OUT $file_foot_format;               # t@Ctb^o
# o͏I
close OUT;
