/*---------------------------------------------------------------------------*
  Project:  CTR - ELF Loader
  File:     loader_subset.h

  Copyright 2006,2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _LOADER_SUBSET_H_
#define _LOADER_SUBSET_H_

#include "elf.h"
#include "elf_loader.h"


/*------------------------------------------------------
  xjobt@ɃRs[
    start : ĂяoAhX
    data : ѐAhX
 -----------------------------------------------------*/
void* i_elCopyVeneerToBuffer( ElDesc* elElfDesc, u32 start, u32 data, s32 threshold);


/*------------------------------------------------------
  xjobt@ɃRs[
    start : Ăяo
    data : ѐ
    threshold : ͈͓̔ɊɃxjΎg܂킷
 -----------------------------------------------------*/
void* i_elCopyV4tVeneerToBuffer( ElDesc* elElfDesc, u32 start, u32 data, s32 threshold);


/*------------------------------------------------------
  ZOgobt@ɃRs[
 -----------------------------------------------------*/
void* i_elCopySegmentToBuffer( ElDesc* elElfDesc, Elf32_Phdr* Phdr);


/*------------------------------------------------------
  ZNVobt@ɃRs[
 -----------------------------------------------------*/
void* i_elCopySectionToBuffer( ElDesc* elElfDesc, Elf32_Shdr* Shdr);


/*------------------------------------------------------
  ZNVobt@ɊmۂiRs[Ȃj
 -----------------------------------------------------*/
void* i_elAllocSectionToBuffer( ElDesc* elElfDesc, Elf32_Shdr* Shdr);
    

/*------------------------------------------------------
  wCfbNX̃vOwb_obt@Ɏ擾
 -----------------------------------------------------*/
void i_elGetPhdr( ElDesc* elElfDesc, u32 index, Elf32_Phdr* Phdr);


/*------------------------------------------------------
  wCfbNX̃ZNVwb_obt@Ɏ擾
 -----------------------------------------------------*/
void i_elGetShdr( ElDesc* elElfDesc, u32 index, Elf32_Shdr* Shdr);


/*------------------------------------------------------
  wCfbNX̃ZNṼGgobt@Ɏ擾
 -----------------------------------------------------*/
void i_elGetSent( ElDesc* elElfDesc, u32 index, void* entry_buf, u32 offset, u32 size);


/*------------------------------------------------------
  wZNVwb_̎wCfbNX̃Ggobt@Ɏ擾
  iGgTCYŒ̃ZNV̂݁j
 -----------------------------------------------------*/
void i_elGetEntry( ElDesc* elElfDesc, Elf32_Shdr* Shdr, u32 index, void* entry_buf);


/*------------------------------------------------------
  STRZNVwb_̎wCfbNX̕擾
 -----------------------------------------------------*/
void i_elGetStrAdr( ElDesc* elElfDesc, u32 strsh_index, u32 ent_index, char* str, u32 len);


/*------------------------------------------------------
  V{Ē`
 -----------------------------------------------------*/
void i_elRelocateSym( ElDesc* elElfDesc, u32 relsh_index);

/*------------------------------------------------------
  O[oV{AhXe[uɓ
 -----------------------------------------------------*/
void i_elGoPublicGlobalSym( ElDesc* elElfDesc, u32 symtblsh_index);

/*------------------------------------------------------
  i_elRelocateSymi_elGoPublicGlobalSym̒ō쐬V{Xg
  JiǂĂяIŌɂAPIĂłj
 -----------------------------------------------------*/
void i_elFreeSymList( ElDesc* elElfDesc);

/*------------------------------------------------------
  ƂɃV{
 -----------------------------------------------------*/
BOOL i_elDoRelocate( ElDesc* elElfDesc, ElUnresolvedEntry* UnresolvedInfo);


/*------------------------------------------------------
  XgwCfbNXElSymExo
 -----------------------------------------------------*/
//ElSymEx* i_elGetSymExfromList( ElSymEx* SymExStart, u32 index);


/*------------------------------------------------------
  XgwCfbNXElShdrExo
 -----------------------------------------------------*/
ElShdrEx* i_elGetShdrExfromList( ElShdrEx* ShdrExStart, u32 index);


/*------------------------------------------------------
  wCfbNX̃ZNVfobO񂩂ǂ肷
 -----------------------------------------------------*/
BOOL i_elShdrIsDebug( ElDesc* elElfDesc, u32 index);


/*------------------------------------------------------
  elElfDescSymExe[u𒲂ׁAwCfbNX
@wItZbgɂR[hARMTHUMB𔻒肷
 -----------------------------------------------------*/
u32 i_elCodeIsThumb( ElDesc* elElfDesc, u16 sh_index, u32 offset);


/*---------------------------------------------------------
 Gg
 --------------------------------------------------------*/
//void i_elUnresolvedInfoInit( ElUnresolvedEntry* UnresolvedInfo);


/*---------------------------------------------------------
 e[uɃGgǉ
 --------------------------------------------------------*/
//void i_elAddUnresolvedEntry( ElUnresolvedEntry* UnrEnt);


void*     i_elFreeVenTbl( void);


#endif /*_LOADER_SUBSET_H_*/
