/*---------------------------------------------------------------------------*
  Project:  TwlSDK - library - twlmic
  File:     twl_mic_api.c

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: $
  $NoKeywords: $
 *---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*
  ݖ̋@\ƂĈȉ2܂B
@EAuto Gain Control (QCߋ@\j
@EIIR Filter (o̓tB^ : High/Low Pass Filter Ȃǁj

@AA̋@\ CODEC ̃ZJh\[Xił݊ۂĂ邩
@ǂmFƂĂȂ߁A{c\܂B
 ----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*

TWLɂ}CNf[^̏E

݂ FIFO Half DMAN B


 FIFO Half DMAN 

ubN]TCY@@FW[h
C^[o@@@@@FO
][h@@@@@@FW[h
][h@@@@@Fobt@TCY
ReBjAX[hFnee



FIFOɔf[^܂xDMANv
W[h]B
obt@TCY̓]Ɋ荞݂̂
DMAĐݒB

bg
EFIFODMÃ^C~OƍB
EFXȎgɑΉ₷B

fbg
EDMAǂ܂Ői񂾂ȂMIC_GetLastSamplingAddress
@ŐmȃAhXȂB`bNgpđ̂̈ʒu
@\邱Ƃ͉\B

 C^[o 

ubN]TCY@@FW[h
C^[o@@@@@FKؒl
][h@@@@@@Fobt@TCY
][h@@@@@Fobt@TCY
ReBjAX[hFnm



gFIFOɃf[^܂^C~OtZA
C^[ogČ݂ŃubNDMAsB
DMAFIFÕ^C~OĂ\
邪Aobt@TCY]ɍē\B

bg
EDMA̍Đݒ肪KvȂ

fbg
EDMAɂFIFOƂ̃^C~OĂ\B
Êߑ傫ȃobt@TCYɂ͌Ȃ
EDMAǂ܂Ői񂾂ȂMIC_GetLastSamplingAddress
@ŐmȃAhXȂB`bNgpđ̂̈ʒu
@\邱Ƃ͉\B

 荞ݕp 



FIFOɃf[^܂xMIC荞݂𔭐
FIFOCPUłW[h擾B

bg
Eobt@̂ǂ̈ʒu܂Ői񂾂𐳊mɔc\B
@MIC_GetLastSamplingAddressŐmȃAhXԂƂłB

fbg
EpɂɊ荞݂BƂĂ̕pxDS1/16ɂȂB
EMIC_GetLastSamplingAddressɗLpȂȂ炱͂̕肦ȂB

 ----------------------------------------------------------------------------*/

#include <twl.h>
#include <twl/mic.h>
#include <twl/cdc.h>
#include <twl/snd/ARM7/i2s.h>

/*---------------------------------------------------------------------------*
    }N`
 *---------------------------------------------------------------------------*/

#define TWL_MIC_TICK_INIT_VALUE   0

/*---------------------------------------------------------------------------*
    ÓIϐ`
 *---------------------------------------------------------------------------*/

static TWLMICParam sMicParam;	// p[^ۑp
static OSTick sMicTickStart;	// TvOJnTick
static OSTick sMicTickStop;		// TvO~Tick

/*---------------------------------------------------------------------------*
    ֐`
 *---------------------------------------------------------------------------*/

static void TWL_MICi_ExDmaRecvAsync( u32 dmaNo, void *dest, u32 size );
static void TWL_MICi_ExDmaInterruptHandler( void );
static void TWL_MICi_FifoInterruptHandler( void );

/*---------------------------------------------------------------------------*
  Name:         TWL_MIC_DoSampling

  Description:  Pi16bitj̃TvOs܂B

  Arguments:    buffer : TvOʂi[obt@

  Returns:      None
 *---------------------------------------------------------------------------*/
void
TWL_MIC_DoSampling( u16* buffer )
{
	u32 word;
	const u32 WAIT_MAX = 100;
	u32 i;

	// `FbN
	SDK_NULL_ASSERT( buffer );

	// TEh & I2S HON
    SND_Enable();

    // mTvOX^[g
    reg_SND_MICCNT = REG_SND_MICCNT_FIFO_CLR_MASK;
    reg_SND_MICCNT = (u16)(REG_SND_MICCNT_E_MASK | REG_SND_MICCNT_NR_MASK | 
						   MIC_INTR_DISABLE | MIC_SMP_ALL );

	// f[^2ȏ̂҂
	for (i=0;i<WAIT_MAX;i++)
	{
		if (!(reg_SND_MICCNT & REG_SND_MICCNT_FIFO_EMP_MASK))
		{
			break;
		}
	}

	// FIFO̓[hANZX
	word = reg_SND_MIC_FIFO;

	// TvO~
    reg_SND_MICCNT &= ~REG_SND_MICCNT_E_MASK;

	// 16bitli[
	*buffer = (u16)(word & 0x0000ffff);
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MIC_StartAutoSampling

  Description:  I[gTvOJn܂B
				݃mŒ̃TvOɂȂĂ܂B

  Arguments:    param : I[gTvOp̃p[^

  Returns:      None
 *---------------------------------------------------------------------------*/
void
TWL_MIC_StartAutoSampling( TWLMICParam param )
{
    OSIntrMode enabled;
	u32 ch;

	// `FbN
	SDK_ASSERT( param.dmaNo >= MI_EXDMA_CH_MIN && param.dmaNo <= MI_EXDMA_CH_MAX );
	SDK_NULL_ASSERT( param.buffer );

	// DMA~
    TWL_MIC_StopAutoSampling();

	// 荞݋֎~
    enabled = OS_DisableInterrupts();

	// TEh & I2S HON
    SND_Enable();

	// DMAݒ
    TWL_MICi_ExDmaRecvAsync( param.dmaNo, param.buffer, param.size );

	// DMA荞݂̐ݒ
    ch = (u32)param.dmaNo - MI_EXDMA_CH_MIN;
    OS_SetIrqFunction( OS_IE_DMA4 << ch, TWL_MICi_ExDmaInterruptHandler );
    reg_OS_IF  = (OS_IE_DMA4 << ch);
    reg_OS_IE |= (OS_IE_DMA4 << ch);

	// }CNFIFO荞݂̐ݒ
    OS_SetIrqFunction( OS_IE_MIC, TWL_MICi_FifoInterruptHandler );
    reg_OS_IF2  = (OS_IE_MIC >> 32);
    reg_OS_IE2 |= (OS_IE_MIC >> 32);

	// X^[gTickݒ
	sMicTickStart = OS_GetTick();

	// XgbvTickNA
	sMicTickStop = TWL_MIC_TICK_INIT_VALUE;

    // mTvOX^[g
    reg_SND_MICCNT = REG_SND_MICCNT_FIFO_CLR_MASK;		// 
    reg_SND_MICCNT = (u16)(	REG_SND_MICCNT_E_MASK 	| 	// 
							REG_SND_MICCNT_NR_MASK 	| 	// 
							MIC_INTR_OVERFLOW		| 	// FIFOj]Ŋ荞ݔ
							param.frequency );

	// p[^ۑ
	sMicParam = param;

	// 荞ݕA
    (void)OS_RestoreInterrupts(enabled);
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MIC_StopAutoSampling

  Description:  I[gTvO~܂B

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void
TWL_MIC_StopAutoSampling( void )
{
    OSIntrMode enabled = OS_DisableInterrupts();
    u32 dmaNo = sMicParam.dmaNo;

	// XgbvTickݒ
	sMicTickStop = OS_GetTick();

	// }CN~
    reg_SND_MICCNT &= ~REG_SND_MICCNT_E_MASK;

	// }CNFIFO荞݋֎~
    reg_OS_IE2 &= ~(OS_IE_MIC >> 32);
    reg_OS_IF2  =  (OS_IE_MIC >> 32);

    if ( MI_EXDMA_CH_MIN <= dmaNo && dmaNo <= MI_EXDMA_CH_MAX )
    {
        u32 ch = dmaNo - MI_EXDMA_CH_MIN;

		// DMA~
        MIi_StopExDma( dmaNo );

		// DMA荞݋֎~
        reg_OS_IE &= ~(OS_IE_DMA4 << ch);
        reg_OS_IF  =  (OS_IE_DMA4 << ch);
    }

    (void)OS_RestoreInterrupts(enabled);
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MIC_GetLastSamplingAddress

  Description:  ŐVTvOf[^̊i[AhXԂ܂B
				}CNFIFÕf[^擾ɂDMAp܂A
				DMA݂ǂ̈ʒu͒mi܂B
				̂߃TvOoߎԂ茻݂̈ʒu\z܂B

  Arguments:    None

  Returns:      ŐVTvOf[^̃AhXi\zj
 *---------------------------------------------------------------------------*/
void*
TWL_MIC_GetLastSamplingAddress( void )
{
	void* adress;					// ŐVf[^AhX
	OSTick past_tick;				// o߃`bN
	u32 sampling_count;				// \zTvOJEg
	f32 one_sampling_tick;

	// TvO~
	if (sMicTickStop != TWL_MIC_TICK_INIT_VALUE)
	{
		past_tick = sMicTickStop - sMicTickStart;
	}
	// TvOis
	else
	{
		past_tick = OS_GetTick() - sMicTickStart;
	}

	/*
	   TvO[g47.61kHz̏ꍇA
	   VXeNbN33.514MHz 
	   Tick64̃^C}JE^ł邽
	   1TvOɕKvȃ`bN
	   
	   33.514MHz / 47.61kHz / 64 = 10.9988 `bN ƂȂ
	 
	   FPGA{[hł͂ɔɂKv
	*/

	switch ( I2S_GetSamplingRate() )
	{
		case I2S_SAMPLING_RATE_32730:
			switch ( sMicParam.frequency )
			{
				case MIC_SMP_ALL:         // 32.73 kHz
					one_sampling_tick = (f32)OS_SYSTEM_CLOCK * 1 / 32730 / 64;
					break;
    			case MIC_SMP_1_2:         // 16.36 kHz
					one_sampling_tick = (f32)OS_SYSTEM_CLOCK * 2 / 32730 / 64;
					break;
    			case MIC_SMP_1_3:         // 10.91 kHz
					one_sampling_tick = (f32)OS_SYSTEM_CLOCK * 3 / 32730 / 64;
					break;
    			case MIC_SMP_1_4:         // 8.18 kHz
					one_sampling_tick = (f32)OS_SYSTEM_CLOCK * 4 / 32730 / 64;
					break;
			}
			break;
		case I2S_SAMPLING_RATE_47610:
			switch ( sMicParam.frequency )
			{
				case MIC_SMP_ALL:         // 47.61 kHz
					one_sampling_tick = (f32)OS_SYSTEM_CLOCK * 1 / 47610 / 64;
					break;
    			case MIC_SMP_1_2:         // 23.81 kHz
					one_sampling_tick = (f32)OS_SYSTEM_CLOCK * 2 / 47610 / 64;
					break;
    			case MIC_SMP_1_3:         // 15.87 kHz
					one_sampling_tick = (f32)OS_SYSTEM_CLOCK * 3 / 47610 / 64;
					break;
    			case MIC_SMP_1_4:         // 11.90 kHz
					one_sampling_tick = (f32)OS_SYSTEM_CLOCK * 4 / 47610 / 64;
					break;
			}
			break;
	}

	// ݂̃TvOvZ
	sampling_count = (u32)(past_tick / one_sampling_tick);

	// TvOAhXvZ
	adress = (void*)((u16 *)sMicParam.buffer + sampling_count); 

	return adress;
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MIC_SetAmpGain

  Description:  TWL[h̃}CNQC(PGAB)ݒ肵܂B
@@@@@@@@PGABAutoGainControlɂȂĂƂ̂ݗLłB

  Arguments:    gain : ݒQCi0`119 = 0`59.5dBj

  Returns:      None
 *---------------------------------------------------------------------------*/
void
TWL_MIC_SetAmpGain( u8 gain )
{
	SDK_ASSERT( gain >= 0 && gain <= 119 );
	CDC_SetPGAB( gain );
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MIC_GetAmpGain

  Description:  TWL[h̃}CNQC(PGAB)擾܂B

  Arguments:    None

  Returns:      ݒQC
 *---------------------------------------------------------------------------*/
u8
TWL_MIC_GetAmpGain( void )
{
	return CDC_GetPGAB();
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MICi_ExDmaRecvAsync

  Description:  receive data with DMA
                async version

  Arguments:    dmaNo   : DMA channel No.
                buffer  : destination address
                size    : size (byte)

  Returns:      None
 *---------------------------------------------------------------------------*/
static void
TWL_MICi_ExDmaRecvAsync( u32 dmaNo, void *buffer, u32 size )
{
    MIi_ExDmaRecvAsyncCore( 
			dmaNo, 						// DMAԍ
			(void*)REG_MIC_FIFO_ADDR, 	// ]AhX
			buffer, 					// ]AhX
            (u32)size, 					// ]oCg
			(u32)32, 					// ]oCg
            MI_EXDMA_BLOCK_32B, 		// ubN]TCY
			0,							// C^[o 
			MI_EXDMA_PRESCALER_1,		// vXP[1
            MI_EXDMA_CONTINUOUS_OFF, 	// ReBjAX
			MI_EXDMA_SRC_RLD_OFF, 		// Source Reload Don't Care
			MI_EXDMA_DEST_RLD_OFF,		// Destination Reload Off
            MI_EXDMA_TIMING_MIC );		// }CNFIFOn[tN
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MICi_ExDmaInterruptHandler

  Description:  interrupt handler

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
static void 
TWL_MICi_ExDmaInterruptHandler( void )
{
	// [vH
	if ( sMicParam.loop )
	{
 		// DMAĐݒ
        TWL_MICi_ExDmaRecvAsync( sMicParam.dmaNo, sMicParam.buffer, sMicParam.size );

		// X^[gTickĐݒ
		sMicTickStart = OS_GetTick();
	}

	// DMAR[obŇĂяo
	if ( sMicParam.callback )
	{
		sMicParam.callback( sMicParam.loop );
	}
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MICi_FifoInterruptHandler

  Description:  }CNFIFOj]ɌĂяo銄荞݃nh
				݂̎łFIFONAɃTvOăX^[g
				Ă܂B

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
static void 
TWL_MICi_FifoInterruptHandler( void )
{
	// }CN~
    reg_SND_MICCNT &= ~REG_SND_MICCNT_E_MASK;

    // }CNFIFONA
    reg_SND_MICCNT = REG_SND_MICCNT_FIFO_CLR_MASK;

	// mTvOăX^[g
    reg_SND_MICCNT = (u16)(	REG_SND_MICCNT_E_MASK 	|
							REG_SND_MICCNT_NR_MASK 	| 
							MIC_INTR_OVERFLOW		| 	// FIFOj]Ŋ荞ݔ
							sMicParam.frequency );
}

