/*---------------------------------------------------------------------------*
  Project:  TwlSDK - library - twlmic
  File:     twl_mic_server.c

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: $
  $NoKeywords: $
 *---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*
  TWL MicpɏARM7Xbh܂B
  s悯SPIXbhȂǂɋzĂB
 ----------------------------------------------------------------------------*/

#include <twl.h>
#include <twl/mic.h>

/*---------------------------------------------------------------------------*
    }N`
 *---------------------------------------------------------------------------*/

// ACgăRs[
#define MIC_UNPACK_U16(d, s)    \
    (*(d) = (u16)((((u8*)s)[0] << 0) | (((u8*)s)[1] << 8)))
#define MIC_UNPACK_U32(d, s)    \
    (*(d) = (u32)((((u8*)s)[0] << 0) | (((u8*)s)[1] << 8) | (((u8*)s)[2] << 16) | (((u8*)s)[3] << 24)))

/*---------------------------------------------------------------------------*
    ÓIϐ`
 *---------------------------------------------------------------------------*/

static BOOL micInitialized;          	// mFtO
static TWLMICServerWork micWork;      	// [Nϐ܂Ƃ߂\

/*---------------------------------------------------------------------------*
    ֐`
 *---------------------------------------------------------------------------*/

static void TWL_MICi_PxiCallback(PXIFifoTag tag, u32 data, BOOL err);
static void TWL_MICi_ReturnResult(TWLMICPxiCommand command, TWLMICPxiResult result);
static void TWL_MICi_ReturnResultEx(TWLMICPxiCommand command, TWLMICPxiResult result, u8 size, u8* data);
static void TWL_MICi_Thread(void *arg);
static void TWL_MICi_FullCallback( u8 loop );
static BOOL TWL_MICi_SetEntry(TWLMICPxiCommand command, u16 args, ...);

/*---------------------------------------------------------------------------*
  Name:         TWL_MIC_InitServer

  Description:  ARM7ƂƂs߂̏s܂B

  Arguments:    priority

  Returns:      None.
 *---------------------------------------------------------------------------*/
void 
TWL_MIC_InitServer(u32 priority)
{
    // ς݂mF
    if (micInitialized)
    {
        return;
    }
    micInitialized = 1;

    // ԊǗϐNA
    micWork.status = TWL_MIC_STATUS_READY;

    // PXI֘A
    PXI_Init();
    PXI_SetFifoRecvCallback(PXI_FIFO_TAG_TWL_MIC, TWL_MICi_PxiCallback);

    // sXbh쐬N
    OS_InitMessageQueue(&micWork.msgQ, micWork.msgArray, TWL_MIC_MESSAGE_ARRAY_MAX);
    OS_CreateThread(&micWork.thread,
                    TWL_MICi_Thread,
                    0,
                    (void *)(micWork.stack + (TWL_MIC_THREAD_STACK_SIZE / sizeof(u64))),
                    TWL_MIC_THREAD_STACK_SIZE, priority);
    OS_WakeupThreadDirect(&micWork.thread);
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MICi_SetEntry

  Description:  TWL MIC Xbhɑv\񂷂B

  Arguments:    command -   sׂIDwB
                args    -   ɔp[^̐wB
                ...     -   ep[^u32^ŎwB

  Returns:      BOOL    -   \ɐꍇTRUEAsꍇFALSEԂB
 *---------------------------------------------------------------------------*/
static BOOL 
TWL_MICi_SetEntry(TWLMICPxiCommand command, u16 args, ...)
{
    OSIntrMode e;
    void   *w;
    va_list vlist;
    s32     i;

    // ̐`FbN
    if (args > TWL_MIC_MESSAGE_ARGS_MAX)
    {
        return FALSE;
    }

    e = OS_DisableInterrupts();
    micWork.entry[micWork.entryIndex].command = command;

    // w萔̈ǉ
    va_start(vlist, args);
    for (i = 0; i < args; i++)
    {
        micWork.entry[micWork.entryIndex].arg[i] = va_arg(vlist, u32);
    }
    va_end(vlist);

    w = &(micWork.entry[micWork.entryIndex]);
    micWork.entryIndex = (u32)((micWork.entryIndex + 1) % TWL_MIC_MESSAGE_ARRAY_MAX);
    (void)OS_RestoreInterrupts(e);
    return OS_SendMessage(&(micWork.msgQ), w, OS_MESSAGE_NOBLOCK);
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MICi_PxiCallback

  Description:  PXIoRŎMf[^͂B

  Arguments:    tag -  PXIʂ^OB
                data - Mf[^B26bitLB
                err -  PXIʐMɂG[tOB
                       ARM9ɂēʂPXIĂȂƂB

  Returns:      None.
 *---------------------------------------------------------------------------*/
static void TWL_MICi_PxiCallback(PXIFifoTag tag, u32 data, BOOL err)
{
#pragma unused( tag )

    // PXIʐMG[`FbN
    if (err)
    {
        return;
    }
    // 擪f[^
    if (data & TWL_MIC_PXI_START_BIT)
    {
        micWork.total = (u8)((data & TWL_MIC_PXI_DATA_NUMS_MASK) >> TWL_MIC_PXI_DATA_NUMS_SHIFT);
        micWork.current = 0;
        micWork.command = (TWLMICPxiCommand)((data & TWL_MIC_PXI_COMMAND_MASK) >> TWL_MIC_PXI_COMMAND_SHIFT);
        micWork.data[micWork.current++] = (u8)((data & TWL_MIC_PXI_1ST_DATA_MASK) >> TWL_MIC_PXI_1ST_DATA_SHIFT);
    }
    // 㑱f[^
    else
    {
        micWork.data[micWork.current++] = (u8)((data & 0x00FF0000) >> 16);
        micWork.data[micWork.current++] = (u8)((data & 0x0000FF00) >> 8);
        micWork.data[micWork.current++] = (u8)((data & 0x000000FF) >> 0);
    }

    // pPbg
    if (micWork.current >= micWork.total)   // ő2oCg]Ɏ擾
    {
        // MR}h
        switch (micWork.command)
        {
			// PTvO
			case TWL_MIC_PXI_COMMAND_ONE_SAMPLING:
	            if (micWork.status != TWL_MIC_STATUS_READY)
	            {
					// R}hsłԂł͂Ȃ
	                TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_ILLEGAL_STATUS);
	            }
				else
				{
					// TWL MIC Xbhɑv
					if (TWL_MICi_SetEntry( micWork.command, 0 ))
					{
						// Ԃ"PTvOJn҂"
						micWork.status = TWL_MIC_STATUS_ONE_SAMPLING_START;  
					}
					else
					{
						// Gg[sibZ[WL[ɋ󂫖j
    	    			TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_FATAL_ERROR);
					}
				}
				break;

            // I[gTvOJn
			case TWL_MIC_PXI_COMMAND_AUTO_START:
	            if (micWork.status != TWL_MIC_STATUS_READY)
	            {
					// R}hsłԂł͂Ȃ
	                TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_ILLEGAL_STATUS);
	            }
				else
				{
					u32 dmaNo, buffer, size, frequency, loop;
					
					dmaNo = micWork.data[0];
		            MIC_UNPACK_U32(&buffer, &micWork.data[1]);
					MIC_UNPACK_U32(&size, &micWork.data[5]);
					frequency = (u32)(micWork.data[9] << REG_SND_MICCNT_FIFO_SMP_SHIFT);
					loop  = micWork.data[10];

					// TWL MIC Xbhɑv
					if (TWL_MICi_SetEntry( micWork.command, 5, dmaNo, buffer, size, frequency, loop ))
					{
						// Ԃ"TvOJn҂"
						micWork.status = TWL_MIC_STATUS_AUTO_START;  
					}
					else
					{
						// Gg[sibZ[WL[ɋ󂫖j
    	    			TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_FATAL_ERROR);
					}
				}
				break;

			// I[gTvO~
			case TWL_MIC_PXI_COMMAND_AUTO_STOP:
	            if (micWork.status != TWL_MIC_STATUS_AUTO_SAMPLING)
	            {
					// R}hsłԂł͂Ȃ
	                TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_ILLEGAL_STATUS);
	            }
				else
				{
					// TWL MIC Xbhɑv
					if (TWL_MICi_SetEntry( micWork.command, 0 ))
					{
						// Ԃ"TvO~҂"
						micWork.status = TWL_MIC_STATUS_AUTO_END;  	
					}
					else
					{
						// Gg[sibZ[WL[ɋ󂫖j
    	    			TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_FATAL_ERROR);
					}
				}
            	break;

			// ŐVTvOf[^AhX擾
			case TWL_MIC_PXI_COMMAND_GET_LAST_SAMPLING_ADDRESS:

				// TWL MIC Xbhɑv
				if (!TWL_MICi_SetEntry( micWork.command, 0 ))
				{
					// Gg[sibZ[WL[ɋ󂫖j
	    			TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_FATAL_ERROR);
				}
            	break;

            // vO}uAvQCݒ
			case TWL_MIC_PXI_COMMAND_SET_AMP_GAIN:
				{
					u32 gain = micWork.data[0];

					// TWL MIC Xbhɑv
					if (!TWL_MICi_SetEntry( micWork.command, 1, gain ))
					{
						// Gg[sibZ[WL[ɋ󂫖j
    	    			TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_FATAL_ERROR);
					}
				}
				break;

			// vO}uAvQC擾
			case TWL_MIC_PXI_COMMAND_GET_AMP_GAIN:

				// TWL MIC Xbhɑv
				if (!TWL_MICi_SetEntry( micWork.command, 0 ))
				{
					// Gg[sibZ[WL[ɋ󂫖j
	    			TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_FATAL_ERROR);
				}
            	break;

            // m̃R}h
        	default:
            	TWL_MICi_ReturnResult(micWork.command, TWL_MIC_PXI_RESULT_INVALID_COMMAND);
        }
    }
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MICi_ReturnResult

  Description:  PXIoRŏʂARM9ɑMB

  Arguments:    command     - ΏۃR}h
                result      - TWLMICPxiResult̂ЂƂ

  Returns:      None.
 *---------------------------------------------------------------------------*/
static void 
TWL_MICi_ReturnResult(TWLMICPxiCommand command, TWLMICPxiResult result)
{
    u32 pxiData = (u32)(TWL_MIC_PXI_START_BIT | TWL_MIC_PXI_RESULT_BIT |
            ((command << TWL_MIC_PXI_COMMAND_SHIFT) & TWL_MIC_PXI_COMMAND_MASK) |
            ((1 << TWL_MIC_PXI_DATA_NUMS_SHIFT) & TWL_MIC_PXI_DATA_NUMS_MASK) |
            ((result << TWL_MIC_PXI_1ST_DATA_SHIFT) & TWL_MIC_PXI_1ST_DATA_MASK));
    while (0 > PXI_SendWordByFifo(PXI_FIFO_TAG_TWL_MIC, pxiData, 0))
    {
    }
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MICi_ReturnResultEx

  Description:  w㑱f[^PXIoRARM9ɑMB

  Arguments:    command     - ΏۃR}h
                result      - TWLMICPxiResult̂ЂƂ
                size        - tf[^TCY
                data        - tf[^

  Returns:      None.
 *---------------------------------------------------------------------------*/
static void 
TWL_MICi_ReturnResultEx(TWLMICPxiCommand command, TWLMICPxiResult result, u8 size, u8* data)
{
    u32 pxiData = (u32)(TWL_MIC_PXI_START_BIT | TWL_MIC_PXI_RESULT_BIT |
            ((command << TWL_MIC_PXI_COMMAND_SHIFT) & TWL_MIC_PXI_COMMAND_MASK) |
            (((size+1) << TWL_MIC_PXI_DATA_NUMS_SHIFT) & TWL_MIC_PXI_DATA_NUMS_MASK) |
            ((result << TWL_MIC_PXI_1ST_DATA_SHIFT) & TWL_MIC_PXI_1ST_DATA_MASK));
    int i;
    while (0 > PXI_SendWordByFifo(PXI_FIFO_TAG_TWL_MIC, pxiData, 0))
    {
    }
    for (i = 0; i < size; i += 3)
    {
        pxiData = (u32)((data[i] << 16) | (data[i+1] << 8) | data[i+2]);
        while (0 > PXI_SendWordByFifo(PXI_FIFO_TAG_TWL_MIC, pxiData, 0))
        {
        }
    }
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MICi_Thread

  Description:  MIC̎sXbhB

  Arguments:    arg - gpȂB

  Returns:      None.
 *---------------------------------------------------------------------------*/
static void TWL_MICi_Thread(void *arg)
{
#pragma unused( arg )

    OSMessage msg;
    TWLMICMessageData* entry;

    while (TRUE)
    {
        // bZ[Ws܂ŐQ
        (void)OS_ReceiveMessage(&(micWork.msgQ), &msg, OS_MESSAGE_BLOCK);
        entry = (TWLMICMessageData *) msg;

        // R}hɏ]Ċe폈s
        switch (entry->command)
        {
		//--- PTvOJn
        case TWL_MIC_PXI_COMMAND_ONE_SAMPLING:
			if (micWork.status == TWL_MIC_STATUS_ONE_SAMPLING_START)
			{
				u16 temp;
				TWL_MIC_DoSampling( &temp );

				TWL_MICi_ReturnResultEx(entry->command, TWL_MIC_PXI_RESULT_SUCCESS, 
									2, (u8*)&temp );	// ARM9ɏ̐ʒB

				micWork.status = TWL_MIC_STATUS_READY;     				// Ԃ"ʏ푀҂"
			}
			else
			{
	            TWL_MICi_ReturnResult(entry->command, TWL_MIC_PXI_RESULT_ILLEGAL_STATUS);
			}
			break;

		//--- I[gTvOJn
        case TWL_MIC_PXI_COMMAND_AUTO_START:
			if (micWork.status == TWL_MIC_STATUS_AUTO_START)
			{
				TWLMICParam param;

				param.dmaNo     = (u8)entry->arg[0];
	            param.buffer    = (void *)entry->arg[1];
				param.size      = entry->arg[2];
				param.frequency = (MICSampleRate)entry->arg[3];
				param.loop      = (u8)entry->arg[4];
				param.callback = TWL_MICi_FullCallback;
				TWL_MIC_StartAutoSampling( param );

	            TWL_MICi_ReturnResult(entry->command, TWL_MIC_PXI_RESULT_SUCCESS); 	// ARM9ɏ̐ʒB
				micWork.status = TWL_MIC_STATUS_AUTO_SAMPLING;     				// Ԃ"TvO"
			}
			else
			{
	            TWL_MICi_ReturnResult(entry->command, TWL_MIC_PXI_RESULT_ILLEGAL_STATUS);
			}
			break;

		//--- I[gTvO~
        case TWL_MIC_PXI_COMMAND_AUTO_STOP:
	        if ((micWork.status == TWL_MIC_STATUS_AUTO_END) || (micWork.status == TWL_MIC_STATUS_END_WAIT))
	        {
				TWL_MIC_StopAutoSampling();

	            // ARM9ɏ̐ʒB
	            if (micWork.status == TWL_MIC_STATUS_AUTO_END)
	            {
		            TWL_MICi_ReturnResult(TWL_MIC_PXI_COMMAND_AUTO_STOP, TWL_MIC_PXI_RESULT_SUCCESS);
	            }
	            // ԂXV
	            micWork.status = TWL_MIC_STATUS_READY;     // Ԃ"ʏ푀҂"
			}
	        else
	        {
	            TWL_MICi_ReturnResult(entry->command, TWL_MIC_PXI_RESULT_ILLEGAL_STATUS);
	        }
			break;

		//--- ŐVTvOf[^AhX擾
        case TWL_MIC_PXI_COMMAND_GET_LAST_SAMPLING_ADDRESS:
			{
				void* adress = TWL_MIC_GetLastSamplingAddress();
	
				TWL_MICi_ReturnResultEx(entry->command, TWL_MIC_PXI_RESULT_SUCCESS, 
									4, (u8*)&adress );	// ARM9ɏ̐ʒB
			}
			break;

		//--- vO}uAvQCݒ
        case TWL_MIC_PXI_COMMAND_SET_AMP_GAIN:
			{
				u8 gain = (u8)entry->arg[0];
				TWL_MIC_SetAmpGain( gain );
	            TWL_MICi_ReturnResult(entry->command, TWL_MIC_PXI_RESULT_SUCCESS); 	// ARM9ɏ̐ʒB
			}
			break;
		
		//--- vO}uAvQC擾
		case TWL_MIC_PXI_COMMAND_GET_AMP_GAIN:
		{
			u8 gain = TWL_MIC_GetAmpGain();
			TWL_MICi_ReturnResultEx(entry->command, TWL_MIC_PXI_RESULT_SUCCESS, 
									1, (u8*)&gain );	// ARM9ɏ̐ʒB
		}
        //--- T|[gȂR}h
        default:
            TWL_MICi_ReturnResult(entry->command, TWL_MIC_PXI_RESULT_INVALID_COMMAND);
        }
    }
}

/*---------------------------------------------------------------------------*
  Name:         TWL_MICi_FullCallback

  Description:  

  Arguments:    

  Returns:      None.
 *---------------------------------------------------------------------------*/
static void TWL_MICi_FullCallback( u8 loop )
{
	// FULLʒm
	TWL_MICi_ReturnResult(TWL_MIC_PXI_COMMAND_MIC_BUFFER_FULL, TWL_MIC_PXI_RESULT_SUCCESS);

	if ( !loop )
	{
		// TvO~
		if (TWL_MICi_SetEntry( TWL_MIC_PXI_COMMAND_AUTO_STOP, 0 ))
		{
			micWork.status = TWL_MIC_STATUS_END_WAIT;	// Ԃ"TvO҂"
		}
		else
		{
			TWL_MICi_ReturnResult(TWL_MIC_PXI_COMMAND_AUTO_STOP, TWL_MIC_PXI_RESULT_FATAL_ERROR);
		}
	}
}


