/*---------------------------------------------------------------------------*
  Project:  NitroSDK - libraries - spi
  File:     tp_sp.h

  Copyright 2003-2006 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: tp_sp.h,v $
  Revision 1.7  2006/01/18 02:12:27  kitase_hirotake
  do-indent

  Revision 1.6  2005/02/28 05:26:27  yosizaki
  do-indent.

  Revision 1.5  2004/12/29 02:03:59  takano_makoto
  SetStability֐retryp[^p~, range̎XCb`LɕύX

  Revision 1.4  2004/12/20 00:40:55  takano_makoto
  TvOVAlarmdelayݒ

  Revision 1.3  2004/12/15 09:12:40  takano_makoto
  range̎ǉBSDK_TP_AUTO_ADJUST_RANGEɂėLɂȂB

  Revision 1.2  2004/11/05 05:47:24  terui
  SPIR}hɂĂ̐񎖍RgɒǉB

  Revision 1.1  2004/09/06 12:54:18  terui
  libraries/spi/includelibraries/spi/ARM7/includeɈړB
  SPI\̎ɔCB

  Revision 1.9  2004/08/09 13:23:25  takano_makoto
  MICTvO̍ԂTP̂PTvOsł悤ɏC

  Revision 1.8  2004/07/31 08:06:45  terui
  TvOR}h^[QbgHWɂU蕪dlǉ

  Revision 1.7  2004/06/17 11:07:43  terui
  ڐGR}h`ύXB0x94 -> 0x84

  Revision 1.6  2004/05/25 00:58:01  terui
  SPIefoCXpCuוɔC

  Revision 1.5  2004/05/14 04:50:36  yosiokat
  TEGTS̗ɑΉ悤ύX

  Revision 1.4  2004/04/29 10:25:59  terui
  ֐`̈폜ɔύX

  Revision 1.3  2004/04/14 06:26:46  terui
  SPICũ\[XɔXV

  Revision 1.2  2004/04/05 04:47:05  terui
  Change composition.

  $NoKeywords: $
 *---------------------------------------------------------------------------*/

#ifndef LIBRARIES_TP_SP_H_
#define LIBRARIES_TP_SP_H_

#include    <nitro/types.h>
#include    "spi_sp.h"
/////////////////////////////// TWL
#include    "tp_reg.h"
///////////////////////////////


#ifdef __cplusplus
extern "C" {
#endif

/*===========================================================================*/

/*---------------------------------------------------------------------------*
    萔`
 *---------------------------------------------------------------------------*/
/* 2004/11/04 ƈ
 *
 * VKʃfoCX̂߂ɁAȉ̃R}hȊO͗\Ƃ܂B
 * ARM7TPRg[ɂȊÕR}h𔭍sKvꍇ
 * \񂳂Ă邱ƂlĒӂĎgpĉB
 *
 * 0x0000   _~[
 * 0x0084   ڐG
 * 0x0091   YTvO
 * 0x0093   YTvO(o[W)
 * 0x00D1   XTvO
 * 0x00D3   XTvO(o[W)
 *
 */
#ifdef  SDK_TEG
    // t@Xgp
#define     TP_COMMAND_SAMPLING_X       0x00D3  // XTvO
#define     TP_COMMAND_SAMPLING_Y       0x0093  // YTvO
#else  // SDK_TS
#if ( SDK_TS_VERSION >= 100 )          // Ver.Dȍ~
        // Ot@Xgp
#define     TP_COMMAND_SAMPLING_X       0x00D1  // XTvO
#define     TP_COMMAND_SAMPLING_Y       0x0091  // YTvO
#else  // Ver.D
        // t@Xgp
#define     TP_COMMAND_SAMPLING_X       0x00D3  // XTvO
#define     TP_COMMAND_SAMPLING_Y       0x0093  // YTvO
#endif
#endif

#define     TP_COMMAND_DETECT_TOUCH     0x0084  // ڐG薽

#define     TP_VALID_BIT_MASK           0x7ff8  // Lf[^rbg
#define     TP_VALID_BIT_SHIFT          3       // xooooooo oooooxxx

#define     TP_VALARM_DELAY_MAX         10

#define TP_DATA_SAMPLE_DEPTH_MAX        8
#define TP_DATA_SAMPLE_DEPTH_DEFAULT    5

/*---------------------------------------------------------------------------*
    \̒`
 *---------------------------------------------------------------------------*/
// ^b`plɊւIȏ
typedef enum TPStatus
{
    TP_STATUS_READY = 0,               // ʏ푀҂
    TP_STATUS_AUTO_START,              // TvOJn҂
    TP_STATUS_AUTO_SAMPLING,           // TvO
    TP_STATUS_AUTO_WAIT_END            // TvO~҂
}
TPStatus;

// ^b`plp[N\
typedef struct TPWork
{
    u16     command[SPI_PXI_CONTINUOUS_PACKET_MAX];
    TPStatus status;                   // ^b`plԊǗϐ
    s32     range;                     // 蔻莞̋eUꕝ̃ftHgl
    s32     rangeMin;                  // 蔻莞̋eUꕝ̍ŏl(rangeŎgp)
    OSVAlarm vAlarm[SPI_TP_SAMPLING_FREQUENCY_MAX];     // ^b`plpVA[
    u16     vCount[SPI_TP_SAMPLING_FREQUENCY_MAX];      // ^b`plpVJEgޔGA

}
TPWork;

/*---------------------------------------------------------------------------*
    ֐`
 *---------------------------------------------------------------------------*/
void    TP_Init(void);
void    TP_AnalyzeCommand(u32 data);
void    TP_ExecuteProcess(SPIEntry * entry);

//////////////////////////// TWL
void    TWL_TP_Init(void);
//void    TWL_TP_AnalyzeCommand(u32 data);
//void    TWL_TP_ExecuteProcess(SPIEntry * entry);

void    TWL_TP_SetStabilizationTime( TpSetupTime_t time );
void    TWL_TP_SetPrechargeTime( TpSetupTime_t time );
void    TWL_TP_SetSenseTime( TpSetupTime_t time );
void	TWL_TP_SetDebounceTime( tpDebounce_t time );
void    TWL_TP_SetResolution( TpResolution_t res );
void    TWL_TP_GetResolution( TpResolution_t *res );
void    TWL_TP_SetTouchPanelDataDepth(u8 depth);
void	TWL_TP_SetConversionMode( TpCnversionControl_t control, TpConversionMode_t mode, TpCnversionPin_t pin );
void    TWL_TP_SetInterval( tpInterval_t interval );
void    TWL_TP_EnableNewBufferMode( void );
void    TWL_TP_DisableNewBufferMode( void );
////////////////////////////

#define SDK_TP_AUTO_ADJUST_RANGE       // rangeXCb`

#ifdef SDK_TP_AUTO_ADJUST_RANGE        // rangeXCb`
void    TP_ExecSampling(SPITpData *data, s32 range, u16 *density);
BOOL TWL_TP_ReadBuffer( SPITpData *data, u8 range, u16* density );
#else
void    TP_ExecSampling(SPITpData *data, s32 range);
BOOL TWL_TP_ReadBuffer( SPITpData *data, u8 range );
#endif

/*---------------------------------------------------------------------------*
    CC֐`
 *---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*
  Name:         TP_SPIChangeMode

  Description:  SPIRg[WX^ҏWă^b`plpR}h]
                B̎ɁASPIANbNU[h؂ւB
                
                CODEC̐ɂA
                DS[hłSPINbN2MHzxƂȂ̂ŒӁB
                TWL[hłSPINbN4MHzƂȂ邽߁A
                ̊֐ł͂ȂCDCi_ChangeSpiModegpB

  Arguments:    continuous - SPIANbNUہB'1'1byteʐM̓sxCSグ
                             Ȃ[hBA]̍Ō1oCgł'0'ɂ
                             1byte][hɂȂƉivCSオȂB

  Returns:      None.
 *---------------------------------------------------------------------------*/
static inline void TP_SPIChangeMode(SPITransMode continuous)
{
    reg_SPI_SPICNT = (u16)((0x0001 << REG_SPI_SPICNT_E_SHIFT) | (0x0000 << REG_SPI_SPICNT_I_SHIFT) | (SPI_COMMPARTNER_TP << REG_SPI_SPICNT_SEL_SHIFT) | // gύX
//      ( SPI_COMMPARTNER_PMIC << REG_SPI_SPICNT_SEL_SHIFT ) |              // gύXO
                           (continuous << REG_SPI_SPICNT_MODE_SHIFT) |
                           (0x0000 << REG_SPI_SPICNT_BUSY_SHIFT) |
                           (SPI_BAUDRATE_2MHZ << REG_SPI_SPICNT_BAUDRATE_SHIFT));
}



/*===========================================================================*/

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* LIBRARIES_TP_SP_H_ */

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
