/*---------------------------------------------------------------------------*
  Project:  NitroSDK - libraries - spi
  File:     tp_sp.c

  Copyright 2003-2006 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: tp_sp.c,v $
  Revision 1.15  2006/01/18 02:12:29  kitase_hirotake
  do-indent

  Revision 1.14  2005/02/28 05:26:32  yosizaki
  do-indent.

  Revision 1.13  2004/12/29 02:04:13  takano_makoto
  SetStability֐retryp[^p~

  Revision 1.12  2004/12/20 00:41:05  takano_makoto
  TvOVAlarmdelayݒ

  Revision 1.11  2004/12/15 12:02:51  takano_makoto
  R[h̏ȃTCY

  Revision 1.10  2004/12/15 09:12:19  takano_makoto
  range̎ǉBtp_sp.hSDK_TP_AUTO_ADJUST_RANGEɂėLɂȂB

  Revision 1.9  2004/10/21 04:02:57  terui
  LCD̃C`ύXB

  Revision 1.8  2004/10/20 06:34:45  terui
  LCD̃C`ύX

  Revision 1.7  2004/09/06 13:08:42  terui
  SPI\̎ɔCB

  Revision 1.6  2004/08/10 05:07:44  takano_makoto
  t@XŃTvȌꍇATPi_ExecSamplingInSpaceTime()s
  }CNfoCX̋Nǉ

  Revision 1.5  2004/08/09 13:19:32  takano_makoto
  MICTvOTP̂PTvOsł悤ɏC

  Revision 1.4  2004/07/31 02:29:20  terui
  ICresetꕔύX

  Revision 1.3  2004/07/29 13:09:13  takano_makoto
  TP_InitIC̃Zbgǉ

  Revision 1.2  2004/06/03 11:12:10  terui
  SPIfoCXɃXbhDx𒲐B

  Revision 1.1  2004/05/25 01:05:48  terui
  TPCuSPICu番

  Revision 1.2  2004/04/29 10:20:17  terui
  rʊ֐ōs悤ύX

  Revision 1.1  2004/04/14 06:27:50  terui
  SPICũ\[XɔXV

  $NoKeywords: $
 *---------------------------------------------------------------------------*/

/*
	TP֘ACODECDS[hTWL[ĥłĂARM9瓯֐
@@g悤ɂĂ܂BƂATWL[hƂēɗǂ
@@Ƃ͑ĂȂƂłBS݊̕悩łˁB

	_ł CDC_IsTwlMode() ̌ʂɂ
	DS݊[hTWL[h𕪊򂳂Ă܂B
	RɗĂB
*/

#include    "tp_sp.h"
#include    <twl/cdc/ARM7/cdc_api.h>

//#define PRINT_DEBUG

#ifdef PRINT_DEBUG
#include <nitro/os/common/printf.h>
#define DBG_PRINTF OS_TPrintf
#else
#define DBG_PRINTF( ... )  ((void)0)
#define DBG_modeAR( c )      ((void)0)
#endif

/*---------------------------------------------------------------------------*
    ϐ`
 *---------------------------------------------------------------------------*/
static TPWork tpw;

/*---------------------------------------------------------------------------*
    ֐`
 *---------------------------------------------------------------------------*/
static void TpVAlarmHandler(void *arg);
static void SetStability(u16 range);

/*---------------------------------------------------------------------------*
    ֐`
 *---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*
  Name:         TP_Init

  Description:  ^b`plɊւǗϐB

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/

void TP_Init(void)
{
    s32     i;

    // ԊǗϐNA
    tpw.status = TP_STATUS_READY;
    tpw.range = SPI_TP_DEFAULT_STABILITY_RANGE;
    tpw.rangeMin = SPI_TP_DEFAULT_STABILITY_RANGE;

    // PXIR}hޔp̔zNA
    for (i = 0; i < SPI_PXI_CONTINUOUS_PACKET_MAX; i++)
    {
        tpw.command[i] = 0x0000;
    }

    // VJEgA[
    if (!OS_IsVAlarmAvailable())
    {
        OS_InitVAlarm();
    }
    for (i = 0; i < SPI_TP_SAMPLING_FREQUENCY_MAX; i++)
    {
        OS_CreateVAlarm(&(tpw.vAlarm[i]));
        OS_SetVAlarmTag(&(tpw.vAlarm[i]), SPI_TP_VALARM_TAG);
    }

	if (CDC_IsTwlMode())
	{
    	TWL_TP_DisableNewBufferMode();							// NewBufferMode͎gpTSC2101[hgp
	    TWL_TP_SetResolution( TP_RESOLUTION_12 );				// ^b`plf[^̐x12bit
		TWL_TP_SetInterval(TP_INTERVAL_NONE);					// TSC2101[hł͖	
		TWL_TP_SetConversionMode( 
				TP_CONVERSION_CONTROL_SELF, 
				TP_CONVERSION_MODE_XY,
				TP_CONVERSION_PIN_DATA_AVAILABLE	);			// ϊ[hXYW
		TWL_TP_SetStabilizationTime( TP_SETUP_TIME_100US );		// 傫ƍWl̈萫܂ɃTvOԂ
		TWL_TP_SetSenseTime(         TP_SETUP_TIME_0_1US );		// sense time  Pen Touch  Low Ƀ}XN̂Œ
		TWL_TP_SetPrechargeTime(     TP_SETUP_TIME_0_1US );		// precharge time  Pen Touch  Low Ƀ}XN̂Œ
		TWL_TP_SetDebounceTime( TP_DEBOUNCE_0US );				// 
	}
	else
	{
	    // TPIC̏
	    /*  8NbNMɂCSグĂvƂ͎vA
	       TPRg[RXg_Eiɍւ邱Ƃl
	       24TCNCSグۏ؂ꂽʐM@ƂĂB */
	    SPI_Wait();
	    TP_SPIChangeMode(SPI_TRANSMODE_CONTINUOUS);
	    SPI_SendWait(TP_COMMAND_DETECT_TOUCH);
	    SPI_DummyWait();
	    TP_SPIChangeMode(SPI_TRANSMODE_1BYTE);
	    SPI_DummyWait();
	}
}

/*---------------------------------------------------------------------------*
  Name:         TP_AnalyzeCommand

  Description:  ^b`pl֘APXIR}h͂ȀB
                ł̓Xbhɏv\񂵁AۂSPI̓Xbh
                ōsB

  Arguments:    data  - PXIoRŎ󂯎ARM9̗vR}hB

  Returns:      None.
 *---------------------------------------------------------------------------*/
void TP_AnalyzeCommand(u32 data)
{
    // ApPbgJn`FbN
    if (data & SPI_PXI_START_BIT)
    {
        s32     i;

        // ApPbgJnȂR}hޔzNA
        for (i = 0; i < SPI_PXI_CONTINUOUS_PACKET_MAX; i++)
        {
            tpw.command[i] = 0x0000;
        }
    }
    // Mf[^R}hޔzɑޔ
    tpw.command[(data & SPI_PXI_INDEX_MASK) >> SPI_PXI_INDEX_SHIFT] = (u16)((data &
                                                                             SPI_PXI_DATA_MASK) >>
                                                                            SPI_PXI_DATA_SHIFT);

    if (data & SPI_PXI_END_BIT)
    {
        u16     command;
        u16     wu16[2];

        // Mf[^R}h𒊏o
        command = (u16)((tpw.command[0] & 0xff00) >> 8);

        // R}h
        switch (command)
        {
            // TvO蔻p[^ύX
        case SPI_PXI_COMMAND_TP_SETUP_STABILITY:
            wu16[0] = (u16)(tpw.command[0] & 0x00FF);
            SetStability(wu16[0]);
            break;

            // P̃TvO
        case SPI_PXI_COMMAND_TP_SAMPLING:
            // TPTvOXbhɗ\
            if (!SPIi_SetEntry(SPI_DEVICE_TYPE_TP, (u32)command, 0))
            {
                SPIi_ReturnResult(command, SPI_PXI_RESULT_EXCLUSIVE);
            }
            break;

            // TvOJn
        case SPI_PXI_COMMAND_TP_AUTO_ON:
            // Ԃ`FbN
            if (tpw.status != TP_STATUS_READY)
            {
                // ɎTvȌꍇ͕sȏԂƌȂ
                SPIi_ReturnResult(command, SPI_PXI_RESULT_ILLEGAL_STATUS);
                return;
            }
            // "frequency"p[^`FbN
            wu16[0] = (u16)(tpw.command[0] & 0x00ff);
            if ((wu16[0] == 0) || (wu16[0] > SPI_TP_SAMPLING_FREQUENCY_MAX))
            {
                SPIi_ReturnResult(command, SPI_PXI_RESULT_INVALID_PARAMETER);
                return;
            }
            // "vCount"p[^`FbN
            wu16[1] = tpw.command[1];
            if (wu16[1] >= HW_LCD_LINES)
            {
                SPIi_ReturnResult(command, SPI_PXI_RESULT_INVALID_PARAMETER);
                return;
            }
            // TvOJnXbhɗ\
            if (!SPIi_SetEntry(SPI_DEVICE_TYPE_TP, (u32)command, 2, (u32)wu16[0], (u32)wu16[1]))
            {                          // Xbhւ̏\Ɏs
                SPIi_ReturnResult(command, SPI_PXI_RESULT_EXCLUSIVE);
                return;
            }
            // ԂXV
            tpw.status = TP_STATUS_AUTO_START;  // Ԃ"TvOJn҂"
            break;

            // TvO~
        case SPI_PXI_COMMAND_TP_AUTO_OFF:
            // Ԃ`FbN
            if (tpw.status != TP_STATUS_AUTO_SAMPLING)
            {
                SPIi_ReturnResult(command, SPI_PXI_RESULT_ILLEGAL_STATUS);
                return;
            }
            // TvO~Xbhɗ\
            if (!SPIi_SetEntry(SPI_DEVICE_TYPE_TP, (u32)command, 0))
            {                          // Xbhւ̏\Ɏs
                SPIi_ReturnResult(command, SPI_PXI_RESULT_EXCLUSIVE);
                return;
            }
            // ԂXV
            tpw.status = TP_STATUS_AUTO_WAIT_END;       // Ԃ"TvO~҂"
            break;

            // sȃR}h
        default:
            SPIi_ReturnResult(command, SPI_PXI_RESULT_INVALID_COMMAND);
        }
    }
}

#ifdef SDK_TP_AUTO_ADJUST_RANGE        // range̎XCb`
/*---------------------------------------------------------------------------*
  Name:         TP_AutoAdjustRange

  Description:  ^b`pl̃`^O΍p[^܂B

  Arguments:    tpdata  TvOTPf[^
                density TvO̍Wx

  Returns:      None.
 *---------------------------------------------------------------------------*/
static void TP_AutoAdjustRange(SPITpData *tpdata, u16 density)
{
    static u8 invalid_cnt = 0;
    static u8 valid_cnt = 0;
#define RANGE_MAX       35
#define RANGE_INC_CNT   4
#define RANGE_DEC_CNT   4
#define RANGE_DEC_CONDITION( d, r ) ( (d) < ( (r) >> 1 ) )

    if (!tpdata->e.touch)
    {
        // ^b`ĂȂꍇɂ́AJE^Zbg
        invalid_cnt = 0;
        valid_cnt = 0;
        return;
    }

    // ^b`Ăꍇɂrange̎܂B

    if (tpdata->e.validity)
        // INVALID̏ꍇɂ invalid_cntJEgAbv܂B
    {
        valid_cnt = 0;
        if (++invalid_cnt >= RANGE_INC_CNT)     // 񐔘AINVALID擾ꍇɂrange𒲐
        {
            invalid_cnt = 0;
            if (tpw.range < RANGE_MAX)
            {
                tpw.range += 1;
            }
        }
    }
    else
    {
        // TvOWl蕝ȏɎĂvalid_cntJEgAbv܂B
        invalid_cnt = 0;
        if (!RANGE_DEC_CONDITION(density, tpw.range))
        {
            valid_cnt = 0;
            return;
        }

        if (++valid_cnt >= RANGE_DEC_CNT)
        {
            valid_cnt = 0;
            if (tpw.range > tpw.rangeMin)       // 񐔘Aė]ɎĂꍇɂrange𒲐
            {
                tpw.range -= 1;
                // range炵Ă݂đʖڂꍇɂ͂Ɍ̏Ԃɖ߂悤ɂĂB
                invalid_cnt = RANGE_INC_CNT - 1;
            }
        }
    }
}
#endif

/*---------------------------------------------------------------------------*
  Name:         TP_ExecuteProcess

  Description:  ^b`plɊւۂ̏sB
                ̊֐SPIꌳǗXbhĂяoB

  Arguments:    entry   -   Gg[\̂ւ̃|C^B

  Returns:      None.
 *---------------------------------------------------------------------------*/
void TP_ExecuteProcess(SPIEntry * entry)
{
    switch (entry->process)
    {
        // TvO( VAlarm̃Gg[ )
    case SPI_PXI_COMMAND_TP_AUTO_SAMPLING:
        if (tpw.status != TP_STATUS_AUTO_SAMPLING)
        {
            // TvOłȂꍇ͉ɏI
            return;
        }
        // P̃TvO
    case SPI_PXI_COMMAND_TP_SAMPLING:

        // TvOs
        {
            SPITpData temp;
#ifdef SDK_TP_AUTO_ADJUST_RANGE        // range̎XCb`
            u16     density;
#endif
			// TWL[h
			if (CDC_IsTwlMode())
			{
#ifdef SDK_TP_AUTO_ADJUST_RANGE        // range̎XCb`
				if (TWL_TP_ReadBuffer(&temp, tpw.range, &density))
            	TP_AutoAdjustRange(&temp, density);
#else
				if (TWL_TP_ReadBuffer(&temp, tpw.range))
#endif
				{
		            // VXëɏo( 2oCgANZX )
		            *((u16 *)(&(OS_GetSystemWork()->touch_panel[0]))) = temp.halfs[0];
		            *((u16 *)(&(OS_GetSystemWork()->touch_panel[2]))) = temp.halfs[1];
				}	
			}
			// DS[h
			else
			{
		        // rJn
		        {
		            OSIntrMode e;

		            e = OS_DisableInterrupts();
		            if (!SPIi_CheckException(SPI_DEVICE_TYPE_TP))
		            {
		                (void)OS_RestoreInterrupts(e);
		                // OXbhSPIr
		                SPIi_ReturnResult((u16)(entry->process), SPI_PXI_RESULT_EXCLUSIVE);
		                return;
		            }
		            SPIi_GetException(SPI_DEVICE_TYPE_TP);
		            (void)OS_RestoreInterrupts(e);
		        }

#ifdef SDK_TP_AUTO_ADJUST_RANGE        // range̎XCb`
            	TP_ExecSampling(&temp, tpw.range, &density);
            	TP_AutoAdjustRange(&temp, density);
#else
            	TP_ExecSampling(&temp, tpw.range);
#endif
	            // VXëɏo( 2oCgANZX )
	            *((u16 *)(&(OS_GetSystemWork()->touch_panel[0]))) = temp.halfs[0];
	            *((u16 *)(&(OS_GetSystemWork()->touch_panel[2]))) = temp.halfs[1];
			}

	        // rI
	        SPIi_ReleaseException(SPI_DEVICE_TYPE_TP);
        }
        // ARM9ɏ̐ʒB
        if (entry->process == SPI_PXI_COMMAND_TP_SAMPLING)
        {
            // P̃TvỎ
            SPIi_ReturnResult((u16)(entry->process), SPI_PXI_RESULT_SUCCESS);
        }
        else
        {
            // TvÕCWP[g
            SPIi_ReturnResult((u16)(entry->process), (u16)(entry->arg[0] & 0x00ff));
        }
        break;

        // TvOJn
    case SPI_PXI_COMMAND_TP_AUTO_ON:
        if (tpw.status == TP_STATUS_AUTO_START)
        {
            s32     i;

            // VA[N
            for (i = 0; i < entry->arg[0]; i++)
            {
                // CTvOpxŕAeVJEgvZ
                tpw.vCount[i] = (u16)((entry->arg[1] +
                                       ((i * HW_LCD_LINES) / entry->arg[0])) % HW_LCD_LINES);
                // VJEgA[Jn(݃nhOłȂƂȂ)
                OS_SetPeriodicVAlarm(&(tpw.vAlarm[i]),
                                     (s16)(tpw.vCount[i]),
                                     TP_VALARM_DELAY_MAX, TpVAlarmHandler, (void *)i);
            }
            // ARM9ɏ̐ʒB
            SPIi_ReturnResult((u16)(entry->process), SPI_PXI_RESULT_SUCCESS);
            // ԂXV
            tpw.status = TP_STATUS_AUTO_SAMPLING;       // Ԃ"TvO"
        }
        else
        {
            // ARM9ɏ̎sʒB
            SPIi_ReturnResult((u16)(entry->process), SPI_PXI_RESULT_ILLEGAL_STATUS);
        }
        break;

        // TvO~
    case SPI_PXI_COMMAND_TP_AUTO_OFF:
        if (tpw.status == TP_STATUS_AUTO_WAIT_END)
        {
            // VA[~߂
            OS_CancelVAlarms(SPI_TP_VALARM_TAG);
            // ARM9ɏ̐ʒB
            SPIi_ReturnResult((u16)(entry->process), SPI_PXI_RESULT_SUCCESS);
            // ԂXV
            tpw.status = TP_STATUS_READY;       // Ԃ"ʏ푀҂"
        }
        else
        {
            // ARM9ɏ̎sʒB
            SPIi_ReturnResult((u16)(entry->process), SPI_PXI_RESULT_ILLEGAL_STATUS);
        }
        break;
    }
}

/*---------------------------------------------------------------------------*
  Name:         TpVAlarmHandler

  Description:  VJEgA[̃nhB
                TvOxɎ~܂XbhĊJB

  Arguments:    arg - VJEgA[ID

  Returns:      None.
 *---------------------------------------------------------------------------*/
static void TpVAlarmHandler(void *arg)
{
    // TPTvOXbhɗ\
    if (!SPIi_SetEntry(SPI_DEVICE_TYPE_TP, SPI_PXI_COMMAND_TP_AUTO_SAMPLING, 1, (u32)arg))
    {                                  // Xbhւ̃TvO\Ɏs
        SPITpData temp;

        // TvOf[^U
        temp.e.validity = SPI_TP_VALIDITY_INVALID_XY;
        // VXëɏo( 2oCgANZX )
        *((u16 *)(&(OS_GetSystemWork()->touch_panel[0]))) = temp.halfs[0];
        *((u16 *)(&(OS_GetSystemWork()->touch_panel[2]))) = temp.halfs[1];
        // TvÕCWP[g
        SPIi_ReturnResult(SPI_PXI_COMMAND_TP_AUTO_SAMPLING, (u16)((u32)arg & 0x00ff));
    }
}

/*---------------------------------------------------------------------------*
  Name:         SetStability

  Description:  ^b`pl̈蔻p[^ύXB

  Arguments:    range ľ덷臒l.

  Returns:      None.
 *---------------------------------------------------------------------------*/
static void SetStability(u16 range)
{
    // rangep[^`FbN
    if (range == 0)
    {
        SPIi_ReturnResult(SPI_PXI_COMMAND_TP_SETUP_STABILITY, SPI_PXI_RESULT_INVALID_PARAMETER);
        return;
    }
    // 蔻p[^(Ǘ)ύX
    tpw.range = (s32)range;
    tpw.rangeMin = (s32)range;

    // ARM9ɏ̐ʒB
    SPIi_ReturnResult(SPI_PXI_COMMAND_TP_SETUP_STABILITY, SPI_PXI_RESULT_SUCCESS);
    return;
}

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
