/*---------------------------------------------------------------------------*
  Project:  NitroSDK - HW - include
  File:     armArch.h

  Copyright 2003-2005 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: armArch.h,v $
  Revision 1.12  2005/03/01 01:57:00  yosizaki
  copyright ̔NC.

  Revision 1.11  2005/02/28 05:26:01  yosizaki
  do-indent.

  Revision 1.10  2004/05/03 04:50:46  yada
  add HW_CPU_CLOCK*

  Revision 1.9  2004/04/07 02:03:17  yada
  fix header comment

  Revision 1.8  2004/03/16 11:53:06  yasu
  move HW_READ32/WRITE32 -> MI_ReadWord/WriteWord

  Revision 1.7  2004/02/25 11:28:59  yada
  HW_SYSTEM_CLOCK ǉ

  Revision 1.6  2004/02/14 06:32:31  yasu
  add HW_READ43/WRITE32 macros

  Revision 1.5  2004/02/05 07:09:03  yasu
  change SDK prefix iris -> nitro

  Revision 1.4  2003/12/18 01:52:47  yada
  f[^LbVA߃LbVCl[utÕVtgʒǉ

  Revision 1.3  2003/12/17 11:38:48  yada
  LbV`ǉ

  Revision 1.2  2003/12/12 01:29:00  yada
  HW_PSR_ARM_STATE ǉ

  Revision 1.1  2003/12/12 01:24:46  yada
  hw/systemControl.h  hw/armArch.h Ɩ̕ύX

  Revision 1.2  2003/11/28 01:55:16  yada
  REDSDK03-11-27f

  Revision 1.1  2003/11/04 09:11:24  yada
  (܂ƂĂȂ܂)


  $NoKeywords: $

 *---------------------------------------------------------------------------*/

#ifndef NITRO_HW_SYSTEMCONTROL_H_
#define NITRO_HW_SYSTEMCONTROL_H_

#ifdef __cplusplus
extern "C" {
#endif

#define HW_ICACHE_SIZE              0x2000      //   ߃LbV
#define HW_DCACHE_SIZE              0x1000      // f[^LbV
#define HW_ICACHE_TAG_SIZE          0x0400      //   ߃LbVE^ORAM
#define HW_DCACHE_TAG_SIZE          0x0200      // f[^LbVE^ORAM
#define HW_CACHE_LINE_SIZE          32

#define HW_SYSTEM_CLOCK             33514000    // mɂ33513982?

#define HW_CPU_CLOCK_ARM7           33513982
#define HW_CPU_CLOCK_ARM9           67027964

#ifdef SDK_ARM7
#define HW_CPU_CLOCK                HW_CPU_CLOCK_ARM7
#else
#define HW_CPU_CLOCK                HW_CPU_CLOCK_ARM9
#endif

//**********************************************************************
//              hqhrWX^ERg[rbg
//**********************************************************************

//----------------------------------------------------------------------
//                  vOXe[^XWX^
//----------------------------------------------------------------------

#define HW_PSR_CPU_MODE_MASK       0x1f // bot[h

#define HW_PSR_USER_MODE           0x10 // [U
#define HW_PSR_FIQ_MODE            0x11 // ehp
#define HW_PSR_IRQ_MODE            0x12 // hqp
#define HW_PSR_SVC_MODE            0x13 // X[poCU
#define HW_PSR_ABORT_MODE          0x17 // A{[givtFb`^f[^j
#define HW_PSR_UNDEF_MODE          0x1b // `
#define HW_PSR_SYS_MODE            0x1f // VXe

#define HW_PSR_ARM_STATE           0x0 // `qlXe[g
#define HW_PSR_THUMB_STATE         0x20 // sgtlaXe[g

#define HW_PSR_FIQ_DISABLE         0x40 // ehps
#define HW_PSR_IRQ_DISABLE         0x80 // hqps
#define HW_PSR_IRQ_FIQ_DISABLE     0xc0 // hqpehps

#define HW_PSR_Q_FLAG              0x08000000   // XeBbL[I[o[t[
#define HW_PSR_V_FLAG              0x10000000   // I[o[t[
#define HW_PSR_C_FLAG              0x20000000   // L[^{[^g
#define HW_PSR_Z_FLAG              0x40000000   // [
#define HW_PSR_N_FLAG              0x80000000   // ^


//----------------------------------------------------------------------
//                  VXeRg[RvZbT
//----------------------------------------------------------------------

// WX^Pi}X^Rg[j

#define HW_C1_SB1_BITSET           0x00000078   // WX^PpPŒrbg

#define HW_C1_ITCM_LOAD_MODE       0x00080000   //   ߂sbl [h[h
#define HW_C1_DTCM_LOAD_MODE       0x00020000   // f[^sbl [h[h
#define HW_C1_ITCM_ENABLE          0x00040000   //   ߂sbl Cl[u
#define HW_C1_DTCM_ENABLE          0x00010000   // f[^sbl Cl[u
#define HW_C1_LD_INTERWORK_DISABLE 0x00008000   // [h߂ɂC^[[LO fBZ[u
#define HW_C1_CACHE_ROUND_ROBIN    0x00004000   // LbVuASY Ehriň̃qbgj
#define HW_C1_CACHE_PSEUDO_RANDOM  0x00000000   //                            [_
#define HW_C1_EXCEPT_VEC_UPPER     0x00002000   // OxN^ ʃAhXiɐݒ肵ĉj
#define HW_C1_EXCEPT_VEC_LOWER     0x00000000   //            ʃAhX
#define HW_C1_ICACHE_ENABLE        0x00001000   //   ߃LbV Cl[u
#define HW_C1_DCACHE_ENABLE        0x00000004   // f[^LbV Cl[u
#define HW_C1_LITTLE_ENDIAN        0x00000000   // gGfBA
#define HW_C1_BIG_ENDIAN           0x00000080   // rbOGfBA
#define HW_C1_PROTECT_UNIT_ENABLE  0x00000001   // veNVjbg Cl[u

#define HW_C1_ICACHE_ENABLE_SHIFT 12
#define HW_C1_DCACHE_ENABLE_SHIFT 2


// WX^QiveNV[WELbVݒj

#define HW_C2_PR0_SFT              0   // veNV[WO
#define HW_C2_PR1_SFT              1   //                 P
#define HW_C2_PR2_SFT              2   //                 Q
#define HW_C2_PR3_SFT              3   //                 R
#define HW_C2_PR4_SFT              4   //                 S
#define HW_C2_PR5_SFT              5   //                 T
#define HW_C2_PR6_SFT              6   //                 U
#define HW_C2_PR7_SFT              7   //                 V


// WX^RiveNV[WECgobt@ݒj

#define HW_C3_PR0_SFT              0   // veNV[WO
#define HW_C3_PR1_SFT              1   //                 P
#define HW_C3_PR2_SFT              2   //                 Q
#define HW_C3_PR3_SFT              3   //                 R
#define HW_C3_PR4_SFT              4   //                 S
#define HW_C3_PR5_SFT              5   //                 T
#define HW_C3_PR6_SFT              6   //                 U
#define HW_C3_PR7_SFT              7   //                 V


// WX^TiveNV[WEANZXj

#define HW_C5_PERMIT_MASK          0xf // veNV[WANZX}XN

#define HW_C5_PERMIT_NA            0   //                  ANZXs
#define HW_C5_PERMIT_RW            1   //                  [hCg
#define HW_C5_PERMIT_RO            5   //                  [hI[

#define HW_C5_PR0_SFT              0   // veNV[WO
#define HW_C5_PR1_SFT              4   //                 P
#define HW_C5_PR2_SFT              8   //                 Q
#define HW_C5_PR3_SFT              12  //                 R
#define HW_C5_PR4_SFT              16  //                 S
#define HW_C5_PR5_SFT              20  //                 T
#define HW_C5_PR6_SFT              24  //                 U
#define HW_C5_PR7_SFT              28  //                 V


// WX^UiveNV[WEx[XAhX^TCYj

#define HW_C6_PR_SIZE_MASK         0x0000003e   // veNV[W TCY
#define HW_C6_PR_BASE_MASK         0xfffff000   //                  x[XAhX

#define HW_C6_PR_SIZE_SHIFT        1
#define HW_C6_PR_BASE_SHIFT        12

#define HW_C6_PR_ENABLE            1   // veNV[W Cl[u
#define HW_C6_PR_DISABLE           0   //                  fBZ[u

#define HW_C6_PR_4KB               0x16 // [WTCY Sja
#define HW_C6_PR_8KB               0x18 //                  Wja
#define HW_C6_PR_16KB              0x1a //                PUja
#define HW_C6_PR_32KB              0x1c //                RQja
#define HW_C6_PR_64KB              0x1e //                USja
#define HW_C6_PR_128KB             0x20 //              PQWja
#define HW_C6_PR_256KB             0x22 //              QTUja
#define HW_C6_PR_512KB             0x24 //              TPQja
#define HW_C6_PR_1MB               0x26 //                  Pla
#define HW_C6_PR_2MB               0x28 //                  Qla
#define HW_C6_PR_4MB               0x2a //                  Sla
#define HW_C6_PR_8MB               0x2c //                  Wla
#define HW_C6_PR_16MB              0x2e //                PUla
#define HW_C6_PR_32MB              0x30 //                RQla
#define HW_C6_PR_64MB              0x32 //                USla
#define HW_C6_PR_128MB             0x34 //              PQWla
#define HW_C6_PR_256MB             0x36 //              QTUla
#define HW_C6_PR_512MB             0x38 //              TPQla
#define HW_C6_PR_1GB               0x3a //                  Pfa
#define HW_C6_PR_2GB               0x3c //                  Qfa
#define HW_C6_PR_4GB               0x3e //                  Sfa


// WX^V.PRi߃LbVEvtFb`j

#define HW_C7_ICACHE_PREFCHP_MASK  0xffffffe0   //   ߃LbV vtFb`AhX


// WX^V.POAV.PSiLbVCfbNXj

#define HW_C7_ICACHE_INDEX_MASK    0x00000fe0   //   ߃LbV CfbNX
#define HW_C7_DCACHE_INDEX_MASK    0x000003e0   // f[^LbV CfbNX
#define HW_C7_CACHE_SET_NO_MASK    0xc0000000   //       LbV Zbgm

#define HW_C7_CACHE_INDEX_SHIFT    5
#define HW_C7_CACHE_SET_NO_SHIFT   30


// WX^X.OiLbVbN_Ej

#define HW_C9_LOCKDOWN_SET_NO_MASK 0x00000003   // LbVbN_E Zbgm

#define HW_C9_LOCKDOWN_SET_NO_SHIFT 0

#define HW_C9_LOCKDOWN_LOAD_MODE   0x80000000   // LbVbN_E [h[h


// WX^X.Pisblx[XAhX^TCYj

#define HW_C9_TCMR_SIZE_MASK       0x0000003e   // sbl[W TCY
#define HW_C9_TCMR_BASE_MASK       0xfffff000   //                  x[XAhX

#define HW_C9_TCMR_SIZE_SHIFT      1
#define HW_C9_TCMR_BASE_SHIFT      12

#define HW_C9_TCMR_4KB             0x06 // [WTCY Sja
#define HW_C9_TCMR_8KB             0x08 //                  Wja
#define HW_C9_TCMR_16KB            0x0a //                PUja
#define HW_C9_TCMR_32KB            0x0c //                RQja
#define HW_C9_TCMR_64KB            0x0e //                USja
#define HW_C9_TCMR_128KB           0x10 //              PQWja
#define HW_C9_TCMR_256KB           0x12 //              QTUja
#define HW_C9_TCMR_512KB           0x14 //              TPQja
#define HW_C9_TCMR_1MB             0x16 //                  Pla
#define HW_C9_TCMR_2MB             0x18 //                  Qla
#define HW_C9_TCMR_4MB             0x1a //                  Sla
#define HW_C9_TCMR_8MB             0x1c //                  Wla
#define HW_C9_TCMR_16MB            0x1e //                PUla
#define HW_C9_TCMR_32MB            0x20 //                RQla
#define HW_C9_TCMR_64MB            0x22 //                USla
#define HW_C9_TCMR_128MB           0x24 //              PQWla
#define HW_C9_TCMR_256MB           0x26 //              QTUla
#define HW_C9_TCMR_512MB           0x28 //              TPQla
#define HW_C9_TCMR_1GB             0x2a //                  Pfa
#define HW_C9_TCMR_2GB             0x2c //                  Qfa
#define HW_C9_TCMR_4GB             0x2e //                  Sfa

#ifdef __cplusplus
} /* extern "C" */
#endif

/* NITRO_HW_SYSTEMCONTROL_H_ */
#endif
