/*---------------------------------------------------------------------------*
  Project:  NitroSDK - OS - include
  File:     spinLock.h

  Copyright 2003-2006 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: spinLock.h,v $
  Revision 1.31  2006/01/18 02:12:28  kitase_hirotake
  do-indent

  Revision 1.30  2005/03/01 01:57:00  yosizaki
  copyright ̔NC.

  Revision 1.29  2005/02/28 05:26:01  yosizaki
  do-indent.

  Revision 1.28  2004/09/02 06:28:15  yada
  only change comment

  Revision 1.27  2004/07/23 04:28:23  yada
  OS_UnLock* restored for compatibility

  Revision 1.26  2004/07/23 01:52:32  yada
  inline->static inline

  Revision 1.25  2004/07/23 00:58:43  yada
  rename OS_UnLock* -> OS_Unlock*

  Revision 1.24  2004/07/22 08:21:41  yada
  change some lockID's type u32->u16

  Revision 1.23  2004/06/21 11:02:32  yada
  fix comment. incorrect about return value.

  Revision 1.22  2004/04/07 02:03:17  yada
  fix header comment

  Revision 1.21  2004/03/26 10:37:49  yada
  OS_GetLockID(), OS_ReleaseLockID() ǉ

  Revision 1.20  2004/03/25 07:25:21  yada
  OS_LockCard() J[h̃bNɂĒǉ

  Revision 1.19  2004/03/04 09:48:59  yada
  J[gbW̃bNɌIRQ/FIQ֎~ɂB

  Revision 1.18  2004/02/05 07:27:19  yada
  𕶎IRIŜ NITRO  IRISɖ߂B

  Revision 1.17  2004/02/05 07:09:03  yasu
  change SDK prefix iris -> nitro

  Revision 1.16  2004/01/14 01:43:41  yada
  lockunlock̓rs֐ݒo悤ɂ

  Revision 1.15  2003/12/25 07:29:56  yada
  ^[ɂύX

  Revision 1.14  2003/12/22 13:42:13  yasu
  OS_LockWord/LockByte  struct ^Oǉ

  Revision 1.13  2003/12/18 07:25:26  yada
  svRg폜

  Revision 1.12  2003/12/18 07:18:59  yada
  MAINP, SUBP Dxft@C폜

  Revision 1.11  2003/12/17 06:08:12  yasu
  ׂȏC

  Revision 1.10  2003/12/11 00:35:38  yasu
  target.h ̃RgAEg

  Revision 1.9  2003/12/10 10:56:18  yasu
  ISDPrint ŕKv SpinLock ֐݂̂̈ڐA
  OS_LockWord() -> OS_LockByWord()
  volatile LockWord -> OS_LockWord Ȃǂ̕ύX

  Revision 1.8  2003/12/08 12:21:03  yada
  12/3@REDSDK ւ̕ύXΉ

  Revision 1.7  2003/11/28 01:54:47  yada
  REDSDK03-11-27f

  Revision 1.6  2003/11/14 06:50:13  yada
  VXepӂĂ OS_Halt()  OS_HaltA9() ɁB

  Revision 1.5  2003/11/06 10:35:55  yada
  IRIS_BBNITRO_TEG̏𕪗

  Revision 1.4  2003/11/05 07:29:55  yada
  t@Cl L啶

  Revision 1.2  2003/11/04 09:08:43  yada
  (none)

  Revision 1.1  2003/10/31 04:12:03  yada
  ō쐬


  $NoKeywords: $
 *---------------------------------------------------------------------------*/

#ifndef NITRO_OS_SPINLOCK_H_
#define NITRO_OS_SPINLOCK_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <nitro/types.h>

//======================================================================
//                      bNϐ
//
//EJ[h^J[gbW^botԋL[Nq`l^uq`l|b^c
//  Ȃǂ̂botԂł̋LX[XAbotԑMehen ̐L\[X
//  ̔r䂽߂ɂ̊֐gpB
//======================================================================

// bNhc

#define OS_UNLOCK_ID            0      // bNϐbNĂȂꍇ̂hc
#define OS_MAINP_LOCKED_FLAG    0x40   // CvZbTɂ郍bNmFtO
#define OS_MAINP_LOCK_ID_START  0x40   // CvZbTpbNhc̊蓖ĊJnԍ
#define OS_MAINP_LOCK_ID_END    0x6f   //                               蓖ďIԍ
#define OS_MAINP_DBG_LOCK_ID    0x70   //                               fobK\ԍ
#define OS_MAINP_SYSTEM_LOCK_ID 0x7f   //                               VXe\ԍ
#define OS_SUBP_LOCKED_FLAG     0x80   //   TuvZbTɂ郍bNmFtO
#define OS_SUBP_LOCK_ID_START   0x80   //   TuvZbTpbNhc̊蓖ĊJnԍ
#define OS_SUBP_LOCK_ID_END     0xaf   //                               蓖ďIԍ
#define OS_SUBP_DBG_LOCK_ID     0xb0   //                               fobK\ԍ
#define OS_SUBP_SYSTEM_LOCK_ID  0xbf   //                               VXe\ԍ

#define OS_LOCK_SUCCESS         0      // bN
#define OS_LOCK_ERROR           (-1)   // bNG[

#define OS_UNLOCK_SUCCESS       0      // bN
#define OS_UNLOCK_ERROR         (-2)   // bNG[

#define OS_LOCK_FREE            0      // bN

#define OS_LOCK_ID_ERROR        (-3)   // bNhcG[


//---- structure of lock variable 
typedef volatile struct OSLockWord
{
    u32     lockFlag;
    u16     ownerID;
    u16     extension;
}
OSLockWord;

/*---------------------------------------------------------------------------*
  Name:         OS_InitLock

  Description:  initialize system lock variable 
                and privilege to access shared resources

                * cartridge exclusive control area is not cleared 
                  because debugger uses.

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
void    OS_InitLock(void);

//----------------------------------------------------------------------
//          XsbN
//
//EvZbTԂ⃂W[ԂŋL\[Xr䂷邽߂
//  bNϐ̃XsbNs܂B
//EbN܂Ŏs܂B
//EvZbTԂ̋L\[X͕KbNɎgpĉB
//EvZbTL̃\[X̓^C~OIɒł̂ł
//  bNȂĂ\܂B
//  L\[X̓fobOɌ肵ăbN邱Ƃł܂B
//
//EF
//  lockID              bNID
//  lockp               bNϐ̃|C^
//
//E߂lF
//  OS_LOCK_SUCCESS     bN
//----------------------------------------------------------------------
s32     OS_LockByWord(u16 lockID, OSLockWord *lockp, void (*ctrlFuncp) (void));
s32     OS_LockCartridge(u16 lockID);
s32     OS_LockCard(u16 lockID);
s32     OS_LockExCard(u16 lockID);

//----------------------------------------------------------------------
//          bN̉
//
//EbNAL\[X̃ANZXTuvZbTɓn܂B
//EbNĂȂW[sꍇɂ͉ꂸA
//  OS_UNLOCK_ERROR Ԃ܂B
//
//EF
//  lockID              bNID
//  lockp               bNϐ̃|C^
//
//E߂lF
//  OS_UNLOCK_SUCCESS   bN
//  OS_UNLOCK_ERROR     bNG[
//----------------------------------------------------------------------
s32     OS_UnlockByWord(u16 lockID, OSLockWord *lockp, void (*ctrlFuncp) (void));
s32     OS_UnlockCartridge(u16 lockID);
s32     OS_UnlockCard(u16 lockID);
s32     OS_UnlockExCard(u16 lockID);

//---- for compatibility to old name ('UnLock' <-> 'Unlock')
//     because isd lib calls OS_UnLock*, these cannot be inline.
s32     OS_UnLockByWord(u16 lockID, OSLockWord *lockp, void (*ctrlFuncp) (void));
s32     OS_UnLockCartridge(u16 lockID);
s32     OS_UnLockCard(u16 lockID);

//----------------------------------------------------------------------
//          bN̎s
//
//EP񂾂XsbNs܂B
//EvZbTԂ̋L\[X͕KbNɎgpĉB
//EvZbTL̃\[X̓^C~OIɒł̂ł
//  bNȂĂ\܂B
//  L\[X̓fobOɌ肵ăbN邱Ƃł܂B
//
//EF
//  lockID              bNID
//  lockp               bNϐ̃|C^
//  CtrlFuncp           \[X֐̃|C^
//
//E߂lF
//                    bNiOɊi[ĂIDj
//  OS_LOCK_SUCCESS     bN
//----------------------------------------------------------------------
s32     OS_TryLockByWord(u16 lockID, OSLockWord *lockp, void (*crtlFuncp) (void));
s32     OS_TryLockCartridge(u16 lockID);
s32     OS_TryLockCard(u16 lockID);
s32     OS_TryLockExCard(u16 lockID);

//----------------------------------------------------------------------
//          bNϐ̏LW[ID̓ǂݍ
//
//EbNϐ̏LW[ID ǂݍ݂܂B
//EW[ID 0 ̏ꍇ͂̎_łǂ̃vZbT
//  LĂ̂mFł܂B
//EL\[X̏ꍇ́uCvZbTLĂԁv
//  ݂̂荞݂֎~邱ƂɂĈێ邱Ƃł܂B
//  ̑̏Ԃ̓TuvZbTωĂ܂\܂B
//ELW[ID  0 łĂbNϐĂƂ͌܂B
//
//EF
//  lockp       bNϐ̃|C^
//
//E߂lF    LW[ID
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_ReadOwnerOfLockWord() gpĉB
//----------------------------------------------------------------------
u16     OS_ReadOwnerOfLockWord(OSLockWord *lockp);
#define OS_ReadOwnerOfLockCartridge()  OS_ReadOwnerOfLockWord( (OSLockWord *)HW_CTRDG_LOCK_BUF )
#define OS_ReadOwnerOfLockCard()       OS_ReadOwnerOfLockWord( (OSLockWord *)HW_CARD_LOCK_BUF  )
#define OS_ReadOwnerOfLockExCard()     OS_ReadOwnerOfLockWord( (OSLockWord *)HW_CARD_B_LOCK_BUF  )



/*---------------------------------------------------------------------------*
  Name:         OS_GetLockID

  Description:  get lock ID

  Arguments:    None.

  Returns:      OS_LOCK_ID_ERROR, if fail to get ID

                if ARM9
                   0x40`0x6f       lockID
                else if ARM7
                   0x80`0xaf       lockID
                endif

                *Notice:  ID is allocated only 48 pattern at a highest.

 *---------------------------------------------------------------------------*/
s32     OS_GetLockID(void);


/*---------------------------------------------------------------------------*
  Name:         OS_ReleaseLockID

  Description:  release lock ID

  Arguments:    lockID : id to tend to release

  Returns:      None.
 *---------------------------------------------------------------------------*/
void    OS_ReleaseLockID(u16 lockID);

#ifdef __cplusplus
} /* extern "C" */
#endif

/* NITRO_OS_SPINLOCK_H_ */
#endif
