/*---------------------------------------------------------------------------*
  Project:  TwlSDK - library - aes
  File:     aes_sp.h

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: $
  $NoKeywords: $
 *---------------------------------------------------------------------------*/

#ifndef TWL_AES_SP_H_
#define TWL_AES_SP_H_

#include <twl/types.h>

#ifdef __cplusplus
extern "C" {
#endif

/*===========================================================================*/

/*---------------------------------------------------------------------------*
    萔`
 *---------------------------------------------------------------------------*/
#define     AES_MESSAGE_ARRAY_MAX       4       // XbhpbZ[WL[̃TCY
#define     AES_THREAD_STACK_SIZE       256     // Xbh̃X^bNTCY

typedef enum AESLock
{
    AES_UNLOCKED = 0,
    AES_LOCKED_BY_ARM7,
    AES_LOCKED_BY_ARM9
} AESLock;

/*---------------------------------------------------------------------------*
    \̒`
 *---------------------------------------------------------------------------*/
// AESCup[N\

typedef struct AESWork
{
    OSMessageQueue msgQ;               // XbhpbZ[WL[
    OSMessage msgArray[AES_MESSAGE_ARRAY_MAX];
    // bZ[Wi[obt@
    OSThread thread;                   // AESpXbh
    u64     stack[AES_THREAD_STACK_SIZE / sizeof(u64)];
    // AESpXbh̃X^bN

    AESLock locked;                     // bN

    u8      command;                    // R}h
    u8      current;                    // Mς݃f[^ (oCgP)
    u8      total;                      // ŏIf[^ (1 + 㑱R}h*3)
    u8      data[AES_PXI_DATA_SIZE_MAX];
    // ARM9̃f[^ۑp
}
AESWork;

/*---------------------------------------------------------------------------*
    ֐`
 *---------------------------------------------------------------------------*/
void    AES_Init(u32 priority);         // AyуXbhJn
void    AES_Lock(void);                 // ARM7Ŏg߂ɃbN
BOOL    AES_TryLock(void);              // ARM7Ŏg߂ɃbN݂
void    AES_Unlock(void);               // ARM7̃bN

/*===========================================================================*/

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* TWL_AES_SP_H_ */
