/*---------------------------------------------------------------------------*
  Project:  TwlSDK - library - camera
  File:     control.h

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: $
  $NoKeywords: $
 *---------------------------------------------------------------------------*/

#ifndef TWL_CAMERA_CONTROL_H_
#define TWL_CAMERA_CONTROL_H_

#include <twl/types.h>

#ifdef __cplusplus
extern "C" {
#endif

/*===========================================================================*/

/*---------------------------------------------------------------------------*
    萔`
 *---------------------------------------------------------------------------*/
#define     CAMERA_MESSAGE_ARRAY_MAX       4       // XbhpbZ[WL[̃TCY
#define     CAMERA_THREAD_STACK_SIZE       512     // Xbh̃X^bNTCY

/*---------------------------------------------------------------------------*
    \̒`
 *---------------------------------------------------------------------------*/
// CAMERACup[N\

typedef struct CAMERAWork
{
    OSMessageQueue msgQ;               // XbhpbZ[WL[
    OSMessage msgArray[CAMERA_MESSAGE_ARRAY_MAX];
    // bZ[Wi[obt@
    OSThread thread;                   // CAMERApXbh
    u64     stack[CAMERA_THREAD_STACK_SIZE / sizeof(u64)];
    // CAMERApXbh̃X^bN

    CameraSelect        camera;         // ANeBuJ

    CAMERAPxiCommand    command;        // R}h
    u8      current;                    // Mς݃f[^ (oCgP)
    u8      total;                      // ŏIf[^ (1 + 㑱R}h*3)
    u8      data[CAMERA_PXI_DATA_SIZE_MAX];
    // ARM9̃f[^ۑp
}
CAMERAWork;

/*---------------------------------------------------------------------------*
    ֐`
 *---------------------------------------------------------------------------*/
void    CAMERA_Init(u32 priority);         // AyуXbhJn
void    CAMERA_Lock(void);                 // ARM7Ŏg߂ɃbN
BOOL    CAMERA_TryLock(void);              // ARM7Ŏg߂ɃbN݂
void    CAMERA_Unlock(void);               // ARM7̃bN

/*===========================================================================*/

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* TWL_CAMERA_CONTROL_H_ */
