/*---------------------------------------------------------------------------*
  Project:  TwlSDK - camera - include
  File:     fifo.h

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: $
  $NoKeywords: $
 *---------------------------------------------------------------------------*/
#ifndef TWL_CAMERA_FIFO_H_
#define TWL_CAMERA_FIFO_H_

/*---------------------------------------------------------------------------*
    萔`
 *---------------------------------------------------------------------------*/
// vgR֘A`
#define CAMERA_PXI_CONTINUOUS_PACKET_MAX       4           // ApPbg̍őA
#define CAMERA_PXI_DATA_SIZE_MAX               ((CAMERA_PXI_CONTINUOUS_PACKET_MAX-1)*3+1) // őf[^

#define CAMERA_PXI_START_BIT                   0x02000000  // 擪pPbgӖ
#define CAMERA_PXI_RESULT_BIT                  0x00008000  // PXỈ

/* 擪pPbĝ݂̋K */
#define CAMERA_PXI_DATA_NUMS_MASK              0x00ff0000  // f[^̈
#define CAMERA_PXI_DATA_NUMS_SHIFT             16          // f[^ʒu
#define CAMERA_PXI_COMMAND_MASK                0x00007f00  // R}hi[̃}XN
#define CAMERA_PXI_COMMAND_SHIFT               8           // R}hi[̈ʒu
#define CAMERA_PXI_1ST_DATA_MASK               0x000000ff  // 擪pPbg̃f[^̈
#define CAMERA_PXI_1ST_DATA_SHIFT              0           // 擪pPbg̃f[^ʒu

/* 㑱pPbĝ݂̋K */
#define CAMERA_PXI_DATA_MASK                   0x00ffffff  // f[^̈
#define CAMERA_PXI_DATA_SHIFT                  0           // f[^ʒu

#ifdef  __cplusplus
extern "C" {
#endif

/*===========================================================================*/

// PXIR}h`
typedef enum CAMERAPxiCommand
{
    CAMERA_PXI_COMMAND_INIT                         = 0x00, // 

    CAMERA_PXI_COMMAND_ACTIVATE                     = 0x10, // ANeBuI
    CAMERA_PXI_COMMAND_OUTPUT_WITH_DUAL_ACTIVATION  = 0x11, // o͑I(ANeBu)

    CAMERA_PXI_COMMAND_RESIZE                       = 0x30, // TCYݒ
    CAMERA_PXI_COMMAND_FRAME_RATE                   = 0x31, // t[[gݒ
    CAMERA_PXI_COMMAND_EFFECT                       = 0x32, // GtFNgݒ
    CAMERA_PXI_COMMAND_FLIP                         = 0x33, // ]ݒ

    CAMERA_PXI_COMMAND_UNKNOWN
}
CAMERAPxiCommand;

// PXIR}hTCY`
typedef enum CAMERAPxiSize
{
    CAMERA_PXI_SIZE_INIT                            = 1,    // camera

    CAMERA_PXI_SIZE_ACTIVATE                        = 1,    // camera
    CAMERA_PXI_SIZE_OUTPUT_WITH_DUAL_ACTIVATION     = 1,    // camera

    CAMERA_PXI_SIZE_RESIZE                          = 5,    // camera, (u16)width, (u16)height
    CAMERA_PXI_SIZE_FRAME_RATE                      = 2,    // camera, rate
    CAMERA_PXI_SIZE_EFFECT                          = 2,    // camera, effect
    CAMERA_PXI_SIZE_FLIP                            = 2,    // camera, flip

    CAMERA_PXI_SIZE_UNKNOWN
}
CAMERAPxiSize;

// `
typedef enum CAMERAPxiResult
{
    CAMERA_PXI_RESULT_SUCCESS = 0,        //  (void/void*^) // ꍇɂ㑱pPbg
    CAMERA_PXI_RESULT_SUCCESS_TRUE = 0,   //  (BOOL^)
    CAMERA_PXI_RESULT_SUCCESS_FALSE,      //  (BOOL^)
    CAMERA_PXI_RESULT_INVALID_COMMAND,    // sPXIR}h
    CAMERA_PXI_RESULT_INVALID_PARAMETER,  // sȃp[^
    CAMERA_PXI_RESULT_ILLEGAL_STATUS,     // CAMERȀԂɂ菈ss
    CAMERA_PXI_RESULT_BUSY,               // ̃NGXgs
    CAMERA_PXI_RESULT_FATAL_ERROR,        // ̑炩̌ŏɎs
    CAMERA_PXI_RESULT_MAX
}
CAMERAPxiResult;


/*===========================================================================*/

#ifdef  __cplusplus
}          /* extern "C" */
#endif

#endif /* TWL_CAMERA_FIFO_H_ */

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
