
#ifndef __SDMC_H__
#define __SDMC_H__

#include <twl.h>
#include <twl/rtfs.h>
#include <twl/devices/sdmc/ARM7/sdmc_types.h>


#ifdef __cplusplus
extern "C" {
#endif



/*********************************************
 RTFSphCoC^tF[X
*********************************************/
BOOL sdmcRtfsIo( int driveno, dword block, void* buffer, word count, BOOLEAN reading);
int  sdmcRtfsCtrl( int driveno, int opcode, void* pargs);
BOOL sdmcRtfsAttach( int driveno);
BOOL sdmcCheckMedia( void);


BOOL nandRtfsIo( int driveno, dword block, void* buffer, word count, BOOLEAN reading);
int  nandRtfsCtrl( int driveno, int opcode, void* pargs);
BOOL nandRtfsAttach( int driveno, int partition_no);
BOOL nandCheckMedia( void);


/*********************************************
 {API
*********************************************/
SDMC_ERR_CODE    sdmcInit( SDMC_DMA_NO dma_no, void (*func1)(void),void (*func2)(void));   /* J[hhCo */
SDMC_ERR_CODE    sdmcReset( void);                                    /* J[hZbg */

SDMC_ERR_CODE    sdmcGetStatus(u16 *status);           /* J[hhCǒ݂̏Ԃ擾 */
u32              sdmcGetCardSize(void);                /* J[hSTCY̎擾 */

/*SD I/FFIFOgă[hij*/
SDMC_ERR_CODE    sdmcReadFifo(void* buf,u32 bufsize,u32 offset,void(*func)(void),SdmcResultInfo *info);/* eXgpJ[h[h */
/*[h*/
SDMC_ERR_CODE    sdmcRead(void* buf,u32 bufsize,u32 offset,void(*func)(void),SdmcResultInfo *info);    /* eXgpJ[h[h */

/*SD I/FFIFOgăCgij*/
SDMC_ERR_CODE    sdmcWriteFifo( const void* buf,u32 bufsize,u32 offset,void(*func)(void),SdmcResultInfo *info);/* eXgpJ[hCg */
/*Cg*/
SDMC_ERR_CODE    sdmcWrite( const void* buf,u32 bufsize,u32 offset,void(*func)(void),SdmcResultInfo *info);    /* eXgpJ[hCg */

u16           sdmcSelectedNo(void);
SDMC_ERR_CODE sdmcSelect( u16 select);


#ifdef __cplusplus
}    /* extern "C" */
#endif


#endif /*__SDMC_H__*/
