
#ifndef __SDMC_TYPES_H__
#define __SDMC_TYPES_H__

#include <twl/types.h>

#ifdef __cplusplus
extern "C" {
#endif



/*********************************************
 |[gԍ
*********************************************/
typedef enum {
    SDMC_PORT_CARD    = 0x400,
    SDMC_PORT_NAND    = 0x401
}SDMC_PORT_NO;


/*********************************************
 DMAԍ
*********************************************/
typedef enum {
    SDMC_USE_DMA_4    = 0,
    SDMC_USE_DMA_5    = 1,
    SDMC_USE_DMA_6    = 2,
    SDMC_USE_DMA_7    = 3,
    SDMC_NOUSE_DMA    = 0xFF
}SDMC_DMA_NO;


/*********************************************
 J[hG[R[hiJ[hG[Xe[^XݒljAvP[VŗLSDCARD_ErrStatusɑ΂
*********************************************/
typedef enum {
    SDMC_NORMAL             =   0,      /* I */
    SDMC_ERR_COMMAND        =   0x0001, /* CMDG[ */
    SDMC_ERR_CRC            =   0x0002, /* CRCG[ */
    SDMC_ERR_END            =   0x0004, /* sG[ */
    SDMC_ERR_TIMEOUT        =   0x0008, /* R}h^CAEg */
    SDMC_ERR_FIFO_OVF       =   0x0010, /* FIFO I[o[t[G[(INFO2Illegal write access to buffer) */
    SDMC_ERR_FIFO_UDF       =   0x0020, /* FIFO A_[t[G[(INFO2Illegal read access to buffer) */
    SDMC_ERR_WP             =   0x0040, /* WriteProtectɂ鏑݃G[ */
    SDMC_ERR_FPGA_TIMEOUT   =   0x0100, /* FPGA ANZX^CAEg */
    SDMC_ERR_PARAM          =   0x0200, /* R}hp[^G[ */
    SDMC_ERR_R1_STATUS      =   0x0800, /* Normal response command J[hXe[^X G[ */
    SDMC_ERR_NUM_WR_SECTORS =   0x1000, /* ݊ZN^ G[ */
    SDMC_ERR_RESET          =   0x2000, /* J[hZbgR}h1.5b^CAEgG[ */
    SDMC_ERR_ILA            =   0x4000, /* C[KANZXG[ */
    SDMC_ERR_INFO_DETECT    =   0x8000  /* J[hroʃG[rbg(IO3) */
}SDMC_ERR_CODE;


/*********************************************
 SDhCoʒʒm\
*********************************************/
typedef struct {
    u16    b_flags;                     /* e         */
    u16    result;                      /* s         */
    u32    resid;                       /* ǂ()TCY */
} SdmcResultInfo;





/*********************************************
 SD|[gԕۑp\
*********************************************/
typedef struct
{
    u16           SD_CID[8];    /* CIDۑp (Card IDentification register) : ID*/
    u16           SD_CSD[8];    /* CSDۑp (Card Specific Data register) : spec*/
    u16           SD_OCR[2];    /* OCRۑp (Operation Condition Register) : voltage and status*/
    u16           SD_SCR[4];    /* SCRۑp (Sd card Configulation Register) : bus-width, card-ver, etc*/
    u16           SD_RCA;       /* RCAۑp (Relative Card Address register) : address*/
    s16           MMCFlag;
    s16           SDHCFlag;
    s16           SDFlag;
    SDMC_ERR_CODE ErrStatus; /* SDCARD_ErrStatus */
    u32           Status;    /* SDCARD_Status */
    u16           SD_CLK_CTRL_VALUE;
    u16           SD_OPTION_VALUE;

    s16           OutFlag;
    u16           port_no;
}
SDPortContext;





/*********************************************
 SDXybN\
*********************************************/
typedef struct {
    u32     csd_ver2_flag;              //CSDtH[}bgo[W(SDHĈƂ1)
    u32     memory_capacity;            //data areãTCY(512ByteP)
    u32     protected_capacity;         //protected areãTCY(512ByteP)
    u32     card_capacity;              //J[hŜ̃TCY(512ByteP)

    u32     adjusted_memory_capacity;   //memory_capacityV_(heads*secptrack)̔{ɒTCY(cylinders*heads*secptrackɂȂ)
      
    u16     heads;
    u16     secptrack;
    u16     cylinders;
    u16     SC;                         //sectors per cluster
    u16     BU;
    u16     RDE;                        //number of root dir entries(512 fix)
    u32     SS;                         //sector size(512 fix)
    u32     RSC;                        //reserved sector count(1 fix)
//    u32     TS;                         //total sectors
    u16     FATBITS;                    //16 or 32
    u16     SF;                         //sectors per FAT
    u32     SSA;                        //sectors in system area
    u32     NOM;                        //sectors in master boot record
} SdmcSpec;


/*FATp[^ TODO:SdmcSpec𓝍邱*/
typedef struct {
    u32    device_capacity;          //foCXŜ̃TCY(512ByteP)
    u32    adjusted_device_capacity;

    u32    memory_capacity;          //data areãTCY(512ByteP)
    u32    adjusted_memory_capacity; //memory_capacityV_(heads*secptrack)̔{ɒTCY(cylinders*heads*secptrackɂȂ)
  
    u16    volume_cylinders;
    
    u16    heads;
    u16    secptrack;
    u16    cylinders;
    u16    SC;                       //sectors per cluster
    u16    BU;
    u16    RDE;                      //number of root dir entries(512 fix)
    u32    SS;                       //sector size(512 fix)
    u32    RSC;                      //reserved sector count(1 fix)
    u16    FATBITS;                  //16 or 32
    u16    SF;                       //sectors per FAT
    u32    SSA;                      //sectors in system area
    u32    NOM;                      //sectors in master boot record

    u32    begin_sect;
} FATSpec;


#ifdef __cplusplus
}    /* extern "C" */
#endif


#endif /*__SDMC_TYPES_H__*/
