/*---------------------------------------------------------------------------*
  Project:  TwlSDK - mcu - include
  File:     intr.h

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date:: 2008-02-15#$
  $Rev: 4187 $
  $Author: yutaka $
 *---------------------------------------------------------------------------*/
#ifndef TWL_MCU_INTR_H_
#define TWL_MCU_INTR_H_

#include <twl/types.h>
#include <twl/mcu/ARM7/mcu_reg.h>

/*
    CPU荞
*/
#define MCU_IE  OS_IE_GPIO33_2

/*
    MCU荞݃rbg
*/
#define MCU_IRQ_TABLE_MAX   8

/*
    MCU荞ݎ
*/
// ODCvȎ} (AvP[V[eBeB)
//#define MCU_IE_EXTERNAL_DC_TRIGGER      MCU_REG_IRQ_EXTDC_MASK
// obe؂ŏI\ɂȂ (AvP[V[eBeB)
#define MCU_IE_BATTERY_LOW_TRIGGER      MCU_REG_IRQ_BATTLOW_MASK
// obe؂ꐅɂȂ (dOFFƓl̏Jn)
#define MCU_IE_BATTERY_EMPTY_TRIGGER    MCU_REG_IRQ_BATTEMP_MASK
// d{^sԂ𒴂ĉꂽ (Zbg/dOFF̂ǂ炩̔m)
#define MCU_IE_POWER_SWITCH_PRESSED     MCU_REG_IRQ_PWSW_MASK
// d{^ɂdOFFw
#define MCU_IE_POWER_OFF_REQUEST        MCU_REG_IRQ_PWOFF_MASK
// d{^ɂ郊Zbgw
#define MCU_IE_RESET_REQUEST            MCU_REG_IRQ_RESET_MASK

/*
    ubNݒ
*/
#define MCU_BLOCK   OS_MESSAGE_BLOCK
#define MCU_NOBLOCK OS_MESSAGE_NOBLOCK

#ifdef _cplusplus
extern "C" {
#endif

/*
    荞݃nh
*/
typedef void (*MCUIrqFunction)(void);

/*
    d{^̏
*/
typedef enum MCUPwswStatus
{
    MCU_PWSW_UNKNOWN,       // ĂȂ
    MCU_PWSW_IN_PROGRESS,   // Ă邪m
    MCU_PWSW_RESET,         // ZbgƊm肵
    MCU_PWSW_POWER_OFF,     // dOFFƊm肵

    MCU_PWSW_MAX
}
MCUPwswStatus;

/*---------------------------------------------------------------------------*
  Name:         MCU_InitIrq

  Description:  MCŮ荞݂𗘗p\Ƃ

  Arguments:    priority        荞ݏXbh̗Dx(̂ݗL)

  Returns:      None.
 *---------------------------------------------------------------------------*/
void MCU_InitIrq(u32 priority);

/*---------------------------------------------------------------------------*
  Name:         MCU_SetIrqFunction

  Description:  MCU荞݃nh̓o^

  Arguments:    intrBit         ݒ肷MCU荞ݗv
                function        荞݃nh

  Returns:      None
 *---------------------------------------------------------------------------*/
void MCU_SetIrqFunction(u8 intrBit, MCUIrqFunction function);

/*---------------------------------------------------------------------------*
  Name:         MCU_GetIrqFunction

  Description:  MCU荞݃nh̎擾

  Arguments:    intrBit         ݒ肷MCU荞ݗv

  Returns:      ݒς݂̊荞݃nh
 *---------------------------------------------------------------------------*/
MCUIrqFunction MCU_GetIrqFunction(u8 intrBit);

/*---------------------------------------------------------------------------*
  Name:         MCU_CallIrqFunction

  Description:  ̊荞݂ɑΉR[obNĂяo܂B
                PwswStatus͍XV܂B

  Arguments:    intrBit         荞݃nhĂяo
                                MCU荞ݗṽrbgOR

  Returns:      None
 *---------------------------------------------------------------------------*/
void MCU_CallIrqFunction(u8 intrBit);

/*---------------------------------------------------------------------------*
  Name:         MCU_CheckIrq

  Description:  MCŮ荞݂ĂȂmFB
                MCU_REG_IRQ_ADDR𒼐ReadɂgpĂB
                xĊ荞݃nhĂяoꍇ́A
                ^C~OMCU_CallIrqFunction()ĂяoĂB

  Arguments:    callHandler     o^ς݃nhĂяoǂ

  Returns:      Ă荞݂ɑΉMCU_IE_*̃rbgOR
 *---------------------------------------------------------------------------*/
u8 MCU_CheckIrq(BOOL callHandler);

/*---------------------------------------------------------------------------*
  Name:         MCU_GetPwswStatus

  Description:  MCU̓d{^̏Ԃ擾
                ubNꍇAIN_PROGRESSł΁ARESET܂POWER_OFF
                Ȃ܂OS_Sleep(1)

  Arguments:    block           m肵ĂȂȂm肷܂ő҂ǂ
                                MCU_BLOCK: ҂
                                MCU_NOBLOCK: ҂Ȃ

  Returns:      one of MCUPwswStatus
 *---------------------------------------------------------------------------*/
MCUPwswStatus MCU_GetPwswStatus(s32 block);

#if 0
/*---------------------------------------------------------------------------*
  Name:         MCU_ResetPwswStatus

  Description:  MCU̓d{^̏ԂNA (ȂƂɂ)
                MCU_PWSW_IN_PROGRESS̏ꍇ͖

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void MCU_ResetPwswStatus(void);
#endif

#ifdef _cplusplus
} /* extern "C" */
#endif

#endif  // TWL_MCU_INTR_H_
