/*---------------------------------------------------------------------------*
  Project:  TwlSDK - library - camera
  File:     control.h

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: $
  $NoKeywords: $
 *---------------------------------------------------------------------------*/

#ifndef TWL_MIC_SERVER_H_
#define TWL_MIC_SERVER_H_

#include <twl/types.h>

#ifdef __cplusplus
extern "C" {
#endif

/*===========================================================================*/

/*---------------------------------------------------------------------------*
    萔`
 *---------------------------------------------------------------------------*/
#define     TWL_MIC_MESSAGE_ARRAY_MAX       4       // XbhpbZ[WL[̃TCY
#define     TWL_MIC_THREAD_STACK_SIZE       512     // Xbh̃X^bNTCY
#define     TWL_MIC_MESSAGE_ARGS_MAX    	7		// bZ[W̍ől

// }CNɊւIȏ
typedef enum _TWLMICStatus
{
    TWL_MIC_STATUS_READY = 0,              // ʏ푀҂
    TWL_MIC_STATUS_ONE_SAMPLING_START,     // PTvOJn҂
    TWL_MIC_STATUS_AUTO_START,             // TvOJn҂
    TWL_MIC_STATUS_AUTO_SAMPLING,          // TvO
    TWL_MIC_STATUS_AUTO_END,               // TvOI҂
    TWL_MIC_STATUS_END_WAIT                // TvO҂(obt@FULL̎I)
}
TWLMICStatus;

/*---------------------------------------------------------------------------*
    \̒`
 *---------------------------------------------------------------------------*/
 
// TWL}CNpbZ[Wf[^\
typedef struct _TWLMICMessageData
{
    TWLMICPxiCommand     command;
    u32     arg[TWL_MIC_MESSAGE_ARGS_MAX];
}
TWLMICMessageData;
 
// MICCup[N\

typedef struct _TWLMICServerWork
{
    OSMessageQueue msgQ;               							// XbhpbZ[WL[
    OSMessage msgArray[TWL_MIC_MESSAGE_ARRAY_MAX];				// bZ[Wi[obt@
    TWLMICMessageData entry[TWL_MIC_MESSAGE_ARRAY_MAX];			// bZ[W̎
    u32     entryIndex;											// Gg[CfbNX
    OSThread thread;                   							// TWL-MICpXbh
    u64     stack[TWL_MIC_THREAD_STACK_SIZE / sizeof(u64)];		// TWL-MICpXbh̃X^bNiłj
    TWLMICStatus status;                  						// }CNԊǗϐ
    TWLMICPxiCommand    command;        						// ARM9̃R}hۑp
    u8      data[TWL_MIC_PXI_DATA_SIZE_MAX];					// ARM9̃f[^ۑp
    u8      current;                    						// Mς݃f[^ (oCgP)
    u8      total;                      						// ŏIf[^ (1 + 㑱R}h*3)
}
TWLMICServerWork;

/*---------------------------------------------------------------------------*
    ֐`
 *---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*
  Name:         TWL_MIC_InitServer

  Description:  ARM7ƂƂs߂̏s܂B

  Arguments:    priority

  Returns:      None.
 *---------------------------------------------------------------------------*/
void TWL_MIC_InitServer( u32 priority );	// AyуXbhJn

/*===========================================================================*/

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* TWL_MIC_SERVER_H_ */
