/*---------------------------------------------------------------------------*
  Project:  TwlSDK - mic - include
  File:     fifo.h

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: $
  $NoKeywords: $
 *---------------------------------------------------------------------------*/
#ifndef TWL_MIC_FIFO_H_
#define TWL_MIC_FIFO_H_

/*---------------------------------------------------------------------------*
    萔`
 *---------------------------------------------------------------------------*/
// vgR֘A`
#define TWL_MIC_PXI_CONTINUOUS_PACKET_MAX   			10  // ApPbg̍őA
#define TWL_MIC_PXI_DATA_SIZE_MAX           ((TWL_MIC_PXI_CONTINUOUS_PACKET_MAX-1)*3+1) // őf[^

#define TWL_MIC_PXI_START_BIT                   0x02000000  // 擪pPbgӖ
#define TWL_MIC_PXI_RESULT_BIT                  0x00008000  // PXỈ

/* 擪pPbĝ݂̋K */
#define TWL_MIC_PXI_DATA_NUMS_MASK              0x00ff0000  // f[^̈
#define TWL_MIC_PXI_DATA_NUMS_SHIFT             16          // f[^ʒu
#define TWL_MIC_PXI_COMMAND_MASK                0x00007f00  // R}hi[̃}XN
#define TWL_MIC_PXI_COMMAND_SHIFT               8           // R}hi[̈ʒu
#define TWL_MIC_PXI_1ST_DATA_MASK               0x000000ff  // 擪pPbg̃f[^̈
#define TWL_MIC_PXI_1ST_DATA_SHIFT              0           // 擪pPbg̃f[^ʒu

/* 㑱pPbĝ݂̋K */
#define TWL_MIC_PXI_DATA_MASK                   0x00ffffff  // f[^̈
#define TWL_MIC_PXI_DATA_SHIFT                  0           // f[^ʒu

#ifdef  __cplusplus
extern "C" {
#endif

/*===========================================================================*/

// PXIR}h`
typedef enum _TWLMICPxiCommand
{
	TWL_MIC_PXI_COMMAND_ONE_SAMPLING			  = 0x34, // PTvO
    TWL_MIC_PXI_COMMAND_AUTO_START                = 0x35, // TvOX^[g
    TWL_MIC_PXI_COMMAND_AUTO_STOP                 = 0x36, // TvOXgbv
	TWL_MIC_PXI_COMMAND_GET_LAST_SAMPLING_ADDRESS = 0x37, // ŐVTvOf[^̃AhX擾
	TWL_MIC_PXI_COMMAND_SET_AMP_GAIN 			  = 0x38, // PGABݒ
	TWL_MIC_PXI_COMMAND_GET_AMP_GAIN              = 0x39, // PGAB擾
	TWL_MIC_PXI_COMMAND_MIC_BUFFER_FULL			  = 0x50, // obt@t̒ʒm
    TWL_MIC_PXI_COMMAND_UNKNOWN
}
TWLMICPxiCommand;

// PXIR}htf[^TCY`
typedef enum TWLMICPxiSize
{
	TWL_MIC_PXI_SIZE_ONE_SAMPLING				 = 0,    // 0
    TWL_MIC_PXI_SIZE_AUTO_START                  = 11,   // dmaNo(u8) buffer(u32) size(u32) frequency(u8) loop_erable(u8)
    TWL_MIC_PXI_SIZE_AUTO_STOP                   = 0,    // 0
    TWL_MIC_PXI_SIZE_GET_LAST_SAMPLING_ADDRESS   = 0,	 // 0
    TWL_MIC_PXI_SIZE_SET_AMP_GAIN   			 = 1,	 // gain(u8)
    TWL_MIC_PXI_SIZE_GET_AMP_GAIN   			 = 0,	 // 0
    TWL_MIC_PXI_SIZE_UNKNOWN
}
TWLMICPxiSize;

// `
typedef enum TWLMICPxiResult
{
    TWL_MIC_PXI_RESULT_SUCCESS = 0,        //  (void/void*^) // ꍇɂ㑱pPbg
    TWL_MIC_PXI_RESULT_INVALID_COMMAND,    // sPXIR}h
    TWL_MIC_PXI_RESULT_INVALID_PARAMETER,  // sȃp[^
    TWL_MIC_PXI_RESULT_ILLEGAL_STATUS,     // Ԃɂ菈ss\
    TWL_MIC_PXI_RESULT_BUSY,               // ̃NGXgs
    TWL_MIC_PXI_RESULT_FATAL_ERROR,        // ̑炩̌ŏɎs
    TWL_MIC_PXI_RESULT_MAX
}
TWLMICPxiResult;

/*===========================================================================*/

#ifdef  __cplusplus
}          /* extern "C" */
#endif

#endif /* TWL_MIC_FIFO_H_ */

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/
