/*---------------------------------------------------------------------------*
  Project:  TWL - ELF Loader
  File:     loader_subset.h

  Copyright 2006,2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _LOADER_SUBSET_H_
#define _LOADER_SUBSET_H_

#include "types.h"
#include "elf.h"
#include "elf_loader.h"


/*------------------------------------------------------
  V{̒gobt@ɃRs[
 -----------------------------------------------------*/
void* ELi_CopySymStrToBuffer( ELHandle* ElfHandle, ELShdrEx* SymStrShdrEx);


/*------------------------------------------------------
  ZNV̒gobt@ɃRs[
 -----------------------------------------------------*/
void* ELi_CopyShStrToBuffer( ELHandle* ElfHandle, Elf32_Shdr* Shdr);


/*------------------------------------------------------
  V{Gg܂Ƃ߂ăobt@ɃRs[
 -----------------------------------------------------*/
void* ELi_CopySymToBuffer( ELHandle* ElfHandle);


/*------------------------------------------------------
  ZNVobt@ɃRs[
 -----------------------------------------------------*/
void* ELi_CopySectionToBuffer( ELHandle* ElfHandle, Elf32_Shdr* Shdr);


/*------------------------------------------------------
  ZNVobt@ɊmۂiRs[Ȃj
 -----------------------------------------------------*/
void* ELi_AllocSectionToBuffer( ELHandle* ElfHandle, Elf32_Shdr* Shdr);
    

/*------------------------------------------------------
  wCfbNX̃ZNVwb_obt@Ɏ擾
 -----------------------------------------------------*/
void ELi_GetShdr( ELHandle* ElfHandle, u32 index, Elf32_Shdr* Shdr);


/*------------------------------------------------------
  wCfbNX̃ZNṼGgobt@Ɏ擾
 -----------------------------------------------------*/
void ELi_GetSent( ELHandle* ElfHandle, u32 index, void* entry_buf, u32 offset, u32 size);


/*------------------------------------------------------
  wZNVwb_̎wCfbNX̃Ggobt@Ɏ擾
	iGgTCYŒ̃ZNV̂݁j
 -----------------------------------------------------*/
void ELi_GetEntry( ELHandle* ElfHandle, Elf32_Shdr* Shdr, u32 index, void* entry_buf);


/*------------------------------------------------------
  STRZNVwb_̎wCfbNX̕擾
 -----------------------------------------------------*/
void ELi_GetStrAdr( ELHandle* ElfHandle, u32 strsh_index, u32 ent_index, char* str, u32 len);


/*------------------------------------------------------
  V{Xg쐬

 -----------------------------------------------------*/
void ELi_BuildSymList( ELHandle* elElfDesc, u32 symsh_index, u32** sym_table);


/*------------------------------------------------------
  V{XgJ

 -----------------------------------------------------*/
void ELi_FreeSymList( ELHandle* elElfDesc, u32** sym_table);


/*------------------------------------------------------
  V{Ē`
 -----------------------------------------------------*/
void ELi_RelocateSym( ELHandle* ElfHandle, u32 relsh_index);


/*------------------------------------------------------
    makelstp֐
    V{ZNV̒GLOBALȂ̂
    AhXe[uɓo^
 -----------------------------------------------------*/
void ELi_DiscriminateGlobalSym( ELHandle* ElfHandle, u32 symsh_index);


/*------------------------------------------------------
  ƂɃV{
 -----------------------------------------------------*/
u32	ELi_DoRelocate( ELUnresolvedEntry* UnresolvedInfo);


/*------------------------------------------------------
  XgwCfbNXELSymExo
 -----------------------------------------------------*/
ELSymEx* ELi_GetSymExfromList( ELSymEx* SymExStart, u32 index);


/*------------------------------------------------------
  XgwCfbNXELShdrExo
 -----------------------------------------------------*/
ELShdrEx* ELi_GetShdrExfromList( ELShdrEx* ShdrExStart, u32 index);


/*------------------------------------------------------
  wCfbNX̃ZNVfobO񂩂ǂ肷
 -----------------------------------------------------*/
BOOL ELi_ShdrIsDebug( ELHandle* ElfHandle, u32 index);


/*------------------------------------------------------
  ElfHandleSymExe[u𒲂ׁAwCfbNX
@wItZbgɂR[hARMTHUMB𔻒肷
 -----------------------------------------------------*/
u32 ELi_CodeIsThumb( ELHandle* ElfHandle, u16 sh_index, u32 offset);


/*---------------------------------------------------------
 Gg
 --------------------------------------------------------*/
void ELi_UnresolvedInfoInit( ELUnresolvedEntry* UnresolvedInfo);


/*------------------------------------------------------
  e[uGg폜
 -----------------------------------------------------*/
BOOL ELi_RemoveUnresolvedEntry( ELUnresolvedEntry* UnrEnt);


/*---------------------------------------------------------
 e[uɃGgǉ
 --------------------------------------------------------*/
void ELi_AddUnresolvedEntry( ELUnresolvedEntry* UnrEnt);


/*------------------------------------------------------
  e[uw蕶ɊYGgT
 -----------------------------------------------------*/
ELUnresolvedEntry* ELi_GetUnresolvedEntry( char* ent_name);


#endif	/*_LOADER_SUBSET_H_*/
